:userdoc.
:docprof toc=123.
:title.EULER for OS/2
.******************************************
:h1. Introduction
:p.
This document contains the documentation for EULER.  The OS/2 version of
this file should be an INF file, or the online help.  The UNIX version is a
text extract of the IPF file or a HTML file.  If you are using the UNIX
version, you might find some information here, which is only valid for the
OS/2 version.  Just skip these details.  I was tired of maintaining two
documentation files.
.******************************************
:h1 res=2. General Information
:p.
This section gives information about the origins of EULER,
the author and the copyright notice. Topics are
:ul compact.
:li. :link reftype=hd res=10.Disclaimer:elink.
:li. :link reftype=hd res=1.About EULER:elink.
:li. :link reftype=hd res=30.About the Author:elink.
:eul.
.***********************************
:h2 res=10. Disclaimer
:note.  I will not take responsibility for any damage EULER does to your
data, files or computer, or any other damage.  You use EULER on your own
risk.  You may not sell EULER.  You may distribute the PD version of EULER.
But charges may only cover copy and shipping costs.  The copyright remains
with the author.
.***********************************
:h2 res=1.EULER for OS/2 or UNIX/Xwindows
:i1.Copyright
:p. :hp2.The EULER mathematics program:ehp2.
:artwork align=left name='logo.bmp'.
:p.
:hp2.EULER for OS/2:ehp2. is the OS/2 version of a program for doing 
mathematics on the computer. There is also an ST version (no longer 
updated) and a UNIX/XWindows version. There is a very restricted DOS 
version, which allows no more than a preview of what EULER can do.
:p.
:hp2.EULER:ehp2.  is freeware for educational use.  If you wish to install
EULER on a non-educational network or wish to use it for non-educational
purpose, you need to contact the author and obtain a licence.  You will
also need a licence, if you want extended support.  License fee is 70 DM
per user.  In all cases, the copyright remains with the author.  You may
only distribute the program through the usual freeware or shareware
channels (anonymous ftp or shareware collections).
:p.
For the UNIX version, you will need XWindows to run the program.
Additionally, you must be able to compile the source.  You need access to
the XWindow library and header files, and you need an ANSI-C compatible C
compiler.
:p.
EULER is a program for quickly and interactively computing with real and
complex numbers and matrices, or with intervals.  It can draw your
functions in two and three dimensions.  However, it should be stressed that
EULER is not a computer algebra program.  You should start the :link
reftype=hd res=140.demo:elink.  for more information.  If you are using the
OS/2 version, you can start with loading the welcome notebook.
:p.
:i1.FTP new Version
The most recent Version of EULER for OS/2 or the XWindows version is made 
available on ftp.ku-eichstaett.de in the directories /pub/math and 
/pub/unix/math. You may also look at the Dockumentation via
http&colon.//www.ku-eichstaett.de/MGF/euler.html.
:p.
The :hp2.Copyright:ehp2. on EULER remains with the program author 
(:link reftype=hd res=030.About the author:elink.).
:p.
Refer to the following sections for further information.
:ul compact.
:li. :link reftype=hd res=100.Introduction:elink.
:li. :link reftype=hd res=800.The OS/2 surface:elink.
:li. :link reftype=hd res=200.Using EULER:elink.
:li. :link reftype=hd res=300.Computing with EULER:elink.
:li. :link reftype=hd res=400.Programming EULER:elink.
:li. :link reftype=hd res=500.Files and Directories:elink.
:li. :link reftype=hd res=530.Special Problem Solvers:elink.
:li. :link reftype=hd res=600.Hints, Common Mistakes:elink.
:li. :link reftype=hd res=900.Packages:elink.
:eul.:p.
:p.
There are some additional documentation files.
:ul compact.
:li. EXAMPLES.INF is a OS/2 information file containing some
examples to get you started. Just go to the directory euler\docs
and type "view examples" in a command window, or double click
on the EXAMPLES.INF file. The UNIX version includes the file EXAMPLES.HTML,
which is generated during the complilation of EULER. Use a WWW-Browser to 
load this file.
:li. VERSIONS.INF is for those of you, who updated from an older
EULER version.
:li. The notebook files can be loaded in the OS/2 version of EULER. All 
included notebooks demonstrate various aspects of EULER.
:li. The DEMO.E file can be loaded from EULER. You can learn a lot about 
the program by studying this file and its output.
:eul.
.******************************
:h2 res=030. About the author
:artwork align=left name='rene.bmp'.
:p.
Please, send bug reports and other comments to the address below.
:p.
The author is interested in applications of EULER and will collect them.
These applications will then be included in program updates.  Some
interesting applications are included (with extension *.E).
:p.
The author wishes anyone success using EULER.  Please send me bug reports.
I will do my best to make EULER as bug free as possible.
:p.
:i1.Author's address
:xmp.
Dr. R. Grothmann
Ahornweg 5a
D-85117 Eitensheim
Germany
:exmp.:p.
:p.
:xmp.
EMail&colon.
rene.grothmann@ku-eichstaett.de
grothm@am.ku-eichstaett.de
:exmp.:p.
.********************************************************
:h1 res=100.Introduction
:p.
This section briefly introduces EULER and shows what it is all about.
Available Topics are
:ul compact.
:li. :link reftype=hd res=110.Overview:elink.
:li. :link reftype=hd res=120.Files and Installation:elink.
:li. :link reftype=hd res=130.Command line Parameters:elink.
:li. :link reftype=hd res=140.Demo:elink.
:li. :link reftype=hd res=150.Online Help:elink.
:eul.
.***************************************************
:h2 res=110. Overview
:p.
:i1.Overview
The idea of EULER is a system with the following features&colon.
:ul compact.
:li. Interactive evaluation of numerical expressions with real or complex
values, vectors and matrices, including use of variables.
:li. Built-in functions that can take vectors as input and are then
evaluated for each element of the vector or matrix.
:li. Matrix functions.
:li. Interval arithmetic for result verification.
:li. Exact scalar product.
:li. Statistical functions and random numbers.
:li. Optimization.
:li. 2D- and 3D-plots.
:li. A built-in programming language with parameters and local 
variables. :li. An online help.
:li. A tracing feature for the programming language.
:li. Possibility to read and write raw numerical data or even 
binary data from and to files.
:eul.:p.
Furthermore, EULER for OS/2 has a nice PM interface. It uses
the normal PM on-line help, interacts with the clipboard, has a 
built-in text editor and can print very nice graphics. This version is
in a notebook style. You can edit old commands and execute them again.
Moreover, you can add text to every command. The notebook supports a 
color scheme to distinguish between commands, text and output.
:p.
These features make EULER an ideal tool for the tasks such as&colon.
:ul compact.
:li. Inspecting and discussing functions of one real or complex variable.
:li. Viewing surfaces in parameter representation.
:li. Linear algebra and eigenvalue computation.
:li. Testing numerical algorithms.
:li. Solving differential equations numerically.
:li. Computing polynomials.
:li. Studying interval arithmetic.
:li. Examining and generating sound files.
:eul.
.********************************************************
:h2 res=120.Files and Installation
:p.
:i1.Files
EULER for OS/2 consists of the following files at least&colon.
:ul compact.
:li. EULER.EXE (the program)
:li. EULER.HLP (help file, loaded by the program)
:li. EULER.CFG (is loaded after the start of the program)
:li. UTIL.E (in turn loaded from EULER.CFG)
:eul.
:p.
There are some additional files, which help using the program&colon.
:ul compact.
:li. demo.e (a demo file, see the demo section)
:li. Other *.E files, which contain sample applications.
:li. The Notebook files *.EN, which contain sample notebooks.
:li. The *.INF files, which contain documentation.
:eul.
:p.
You should name your EULER program files *.E. You might also link
*.E to the EULER program. Refer to the OS/2 manual for the
procedure.
:p.
To install EULER, copy the above files in a directory, and start EULER. A 
startup screen indicating the version date will appear. The program will 
prompt for input, using a DOS-like text screen. Of course, you should 
create a OS/2 program object to start EULER. Refer to your OS/2 
documentation.
:p.
:i1.Exit Program
To exit EULER issue the command >quit or close the EULER window.
.******************************************************
:h2 res=130.Command Line Parameters
:p.
:i1.Parameters for EULER
This paragraph is only valid for the OS/2 version. Refer to
readme.unix for the UNIX version (or to XWINDOWS.HTML).
:p.
If EULER is started from a shell, :hp2.command line parameters:ehp2. 
for EULER can be entered. Otherwise, you need to enter the parameters
into the object settings of your EULER program object.
:p.
The paramter :hp2.-n:ehp2. prevents EULER from loading the 
configuration profile. This is useful to reset the parameters to their
default values. Simply save the settings then.
:p.
The parameter :hp2.-p path:ehp2. will set the start directory. You 
must place your EULER.CFG file into this directory. Default is
the current directory (or the EULER.EXE directory, when the
program is started by a program object and the directory field is
blank).
:p.
All other parameter must be :hp2.file names:ehp2. and those files are 
loaded after the start of EULER
(See :link reftype=hd res=220.Loading a File:elink.). Thus EULER
supports drag and drop of
EULER *.e files. Note, that the file EULER.CFG is always loaded as 
first file.  
:p.
The file EULER.CFG contains some commands to set up the EULER system.  It
does in turn load the file UTIL.E.  UTIL contains functions which are
written in the EULER programming language and can be considered being a
part of EULER.  But the user should feel free to change the content of UTIL
to his own needs.
.*******************************************************
:h2 res=140. The Demo
:i1.Demo
:p.
The best way to get a good introduction into EULER is to run the demo.
To do that issue the command
:xmp.    >load "demo"
:exmp.:p.
Do not enter the prompt ">" and press the Return key. Of course, the
file DEMO must be in the active directory.
:p.
You can learn to program EULER by studying the demo file, of course.
:p.
If you are using a notebook version, you should start by loading the
welcome.en notebook.
.*************************************************
:h2 res=150. Online EULER Help
:i1.Online Help
:p.
You can select :hp2.Help:ehp2. from the menu bar or
press the :hp2.F1:ehp2. key to see the help text. Also
:i2 refid=com. help
:xmp.    >help function
:exmp.:p.
will show the help text of a function (see "programming EULER").
:note.For user defined functions, this is a very good way to remember
their purpose and give some documentation to the user.
.*********************************************************
:h1 res=800.The OS/2 surface
:p.
This section describes the use of the windows and menus. Available
topics are
:ul compact.
:li. :link reftype=hd res=810.Windows:elink.
:li. :link reftype=hd res=815.Notebooks:elink.
:li. :link reftype=hd res=816.Keyboard Reference:elink.
:li. :link reftype=hd res=820.Menus:elink.
:li. :link reftype=hd res=830.Settings:elink.
:eul.
.************
:h2 res=810. Using the EULER windows
:i1. Graphics Window
:i1. Text Window
:i1. Cut and Paste
:p.
EULER uses two windows. The text window and the graphics window.
:p.
The text window contains the menu and is designed for user input and output
of EULER.  It is a scrollable window.  One can use the scrollbar to scroll
through available text.  All user input is preceded by a prompt (>).  (See
:link reftype=hd res=210.about the line editor:elink.  for information
about user input.)
:p.
The graphics window is displayed, whenever EULER draws output. Unless 
the graphics screen has been cleared, EULER will redraw the screen
automatically using a backup bitmap or an internal meta file. The 
graphics screen is visible as long as there is no text output. In 
this case, EULER pops the text screen to the forground. Of course,
you may top any of the windows using the mouse as usual.
:p.
You can :hp2.cut and paste:ehp2.  from the text window.  Selecting a text
is done by clicking into the text window with the right mouse button.  A
first click starts a block, a second click ends it.  A third click unmarks
a block.  This is a bit uncommon.  But I considered it the only sensible
way for this program.  Copying to the clipboard buffer is then done with
the menu or with the keyboard.
:p.
You can also copy the graphics window to the clipboard or to a file as
a meta file or a bitmap. 
.************
:h2 res=815. Notebooks
:i1. Notebooks
:p.
From Version 4.00 on, the OS/2 version of EULER uses notebooks.  I.e., old
commands can be edited and changed.  Text may be added to commands to
explain them.  This is a smooth and flexible interface.  Furthermore,
notebook files can be given to other people or can be kept as documented
computations.  However, collections of functions should still be kept in
*.E files.  A notebook could accompany the definitions, which explains the
use of the functions.  Another idea is to use notbooks for teaching
mathematics.
:p.
:note.
The most fact about notebooks is that EULER still uses the sequence of
commands as they are executed. So if you change the value of a variable
and go to previous command, the changed value is used.
:p.
You may not only change previous commands, but also delete them or insert 
new commands. Use the notebook menu to do this. If you change a command and
execute it, its output is removed and EULER proceeds to the next command, 
unless you choose to insert new commands. In this case, a new command is 
inserted after the one, you just executed.
:p.
You can delete the output of commands. To do this, select a text area
(:link reftype=hd res=810.Using EULER Windows:elink.) and use the
command in the notebook menu. All output of selected commands will be 
deleted.
:p.
Notebooks can be loaded from all versions of EULER. However, you cannot
edit them. Use
:xmp.    >notebook "filename"
:exmp.:p.
for that purpose. It will prompt you after each command. If you press the
escape key, the file will be closed immediately. Otherwise, the command
is executed. You can turn the prompt off with
:xmp.    >prompt off
:exmp.:p.
.************
:h2 res=816. Keyboard Reference
:p.
Here is complete reference of keyboard commands for the OS/2 version.
S-key means Shift+key, C-key means Control+key, and A-key means
Alternate+key.
:p.
We start with the general editing commands.
:dl tsize=20 break=fit.
:dt.Esc
:dd.Interrupts functions, sends "endfunction" at the $ prompt.
:dt.Tab
:dd.Brings the graphics window on top. Then any key
will bring the text window on top.
:dt.Left/Right
:dd.Move the cursor in the command line.
:dt.S-Left/S-Right
:dd.Move left/right one word in the command line.
:dt.Up/Down
:dd.Goto previous/next command in notebook.
:dt.S-Up/S-Down
:dd.Recall previous/next command into the command line.
:dt.C-Del/C-Up/C-Down
:dd.Clears the current input line.
:dt.PageUp/PageDown
:dd.Go one page up/down. While editing a command, the cursor
will skip to a command on the previous/next page.
:dt.A-Del/A-Ins
:dd.Delete/Insert a command in the notebook.
:edl.:p.
The following are the clipboard commands
:dl tsize=20 break=fit.
:dt.C-Ins
:dd.Copy all selected text into clipboard.
:dt.S-Ins
:dd.Paste all selected text from the clipboard as command intput.
:dt.S-F6
:dd.Copy only the commands inside the selected text. You could
paste these commands back to re-execute them.
:dt.S-F7
:dd.Paste only the commands from the clipboard into the command
input.
:edl.:p.
Note that the general OS/2 command for cut and paste work in
the text editor windows and in the command text window. I.e.
:dl tsize=20 break=fit.
:dt.C-Ins
:dd.Copy to the clipboard.
:dt.S-Del
:dd.Copy to the clipboard and delete.
:dt.S-Ins
:dd.Paste form the clipboard.
:edl.:p.
The following keyboard commands are shortcuts for menu items.
:dl tsize=20 break=fit.
:dt.F1
:dd.General Help (starts with introduction).
:dt.F2
:dd.Help Index.
:dt.F3
:dd.Help Content.
:dt.F4
:dd.Pastes "Load File" into the command line. You should
set the file to some file name first, using file="name".
If you have an external editor running and editing the
file, F4 will quickly reload the file.
:dt.F5
:dd.Edit the explanation for the current command.
:dt.S-F5
:dd.Delete the explanation for the current command.
:dt.F9
:dd.Edit functions or a text. See 
:link reftype=hd res=836.Edit Text:elink.
:dt.F10
:dd.Opens the load dialog.
:dt.A-F9
:dd.Open a notebook.
:dt.A-F10
:dd.Save the current notebook.
:edl.:p.
.************
:h2 res=820. Menu Items
:p.
Explains the EULER menus. Some menu entries have a keyboard
shortcut (an accelerator) as shown in the menu text. We do not
mention these in the description.
:ul compact.
:li. :link reftype=hd res=821.File:elink.
:li. :link reftype=hd res=822.Edit:elink.
:li. :link reftype=hd res=825.Notebook:elink.
:li. :link reftype=hd res=823.Options:elink.
:li. :link reftype=hd res=824.Help:elink.
:eul.
.*******
:h3 res=821. File Menu
:p.
:hp2.Load:ehp2. will display a file selection dialog and load the 
chosen file using the EULER command
:xmp.    >load "filename"
:exmp.:p.
A specific load operation is :hp2.Load Demo:ehp2..  See :link reftype=hd
res=140.Demo:elink..
:p.
:hp2.File=...:ehp2. displays a file selector and puts the name of the 
chosen file to the variable file. Then the menu option
:hp2.Load File:ehp2. will load this file.
:p.
:hp2.Store Session:ehp2. will store the active session into a chosen
file. These sessions can be restored with :hp2.Restore Session:ehp2..
This options uses the store and restore commands (see
:link reftype=hd res=310.Data Types:elink.).
:p.
:hp2.Save Text:ehp2. will save the text screen into a chosen file.
:hp2.Save Commands:ehp2. will do the same with the user input only.
The latter can be loaded into any session with the load command.
:p.
:hp2.Save Graphics:ehp2. will save the graphics as bitmap or meta 
file, depending from the choice in a submenu.
:p.
:hp2.Print Graphics:ehp2. will print the graphics on the currently 
selected printer
(see :link reftype=hd res=830.Printer Settings:elink.).
Note, that this may take a while, since all graphics will be redrawn
for the printer. The printing gets an own thread. But the EULER intput line
and the computation thread will be blocked during the print. The same 
applies to copying of bitmaps and metafiles to the clipboard or to a file. 
You can only do one of those things at a time.
:p.
:hp2.Exit:ehp2. does what it is supposed to do.
.*******
:h3 res=822. Edit Menu
:p.
:hp2.Copy All:ehp2. will copy the selected block to the clipboard. See
:link reftype=hd res=810.OS/2 Surface:elink. on information about
selection of a block.
:hp2.Copy Commands:ehp2. will copy only the user input in the current
block.
:p.
:hp2.Paste All:ehp2. will paste the text from the clipboard buffer and
use it for EULER input. However, there is size limit for this text
(see :link reftype=hd res=830.Size Settings:elink.).
:hp2.Paste Commands:ehp2. will filter the lines starting with ">" or 
"$" from the clipboard and reenter these commands.
:p.
:hp2.Copy Graphics:ehp2. copies the graphic screen to the clipboard as
a bitmap or meta file.
.*******
:h3 res=825. Notebook Menu
:p.
You find here various commands to edit your notebook.
:p.
You can goto other commands, delete commands or instert new commands.
Moreover, it is possible to delete the output of a group of commands. 
You need to select a text region before you can use this menu option.
(:link reftype=hd res=810.Using EULER windows:elink.).
:p.
The last menu option toggles between insertion of a new command and
skip to the next command after the execution of a command. If you want
to insert a group of commands in your motebook, you may want to toggle
this option on.
.*******
:h3 res=823. Options Menu
:i1.Edit Text
:p.
:hp2.Edit Text:ehp2. calls a small editor. It allows the editing of a 
few EULER lines, which may then be interpreted by the program. E.g.,
it is possible to define a function here, instead of entering it at 
the prompt or load it from an external file. Of course, you can cut 
and paste to this editor as usual. You can also save or load files 
into this editor. Finally, you can inspect a function here by 
selecting it from the function list.
:p.
:i1.Reset Graphics
:hp2.Call Reset:ehp2.  calls the EULER function reset() from UTIL.  This
function contains some commands, which will reset the graphics screen to
default values.  E.g., it will call shrinkwindow, so that font changes can
be respected.  Also, you may encounter problems, if graphics holding is
accidently on.  It is turned off by this function.
:p.
The :hp2.Black and White:ehp2.  option switches to graphics in black
and white only.  Some word processors are unable to print colors
properly.  This option is also useful for faxing.
:p.
You can switch off the :hp2.Notebook Colors:ehp2., if you do not like 
this feature.
:p.
EULER uses at least two processes, one for the interface and one for
the computation.  If you have not permament background process running,
you can use the :hp2.Compute on Idle Time:ehp2. menu point. This will
make your system respond faster during EULER computations.
:p.
For an explanation of the :hp2.Set:ehp2. menu see
:link reftype=hd res=830.Settings:elink. The settings can be saved
with :hp2.Save Settings:ehp2. completely. Selective saving can be
done with the save bottons in the settings dialogs.
.*******
:h3 res=824. Help Menu
:p.
This menu provides the usual help items, such as
:hp2.General Help:ehp2., :hp2.Help Index:ehp2.,
:hp2.Help Content:ehp2. and :hp2.Product Information:ehp2..
.************
:h2 res=830. Settings
:p.
In this menu you will find various settings for EULER. E.g., you
can save the windows size and position here.
:p.
The following settings dialogs exist. Note that the save botton in 
each dialog will only save the settings of that dialog. You can also
save all settings (besides window position) with the save settings 
menu entry.
:ul compact.
:li. :link reftype=hd res=831.Fonts:elink.
:li. :link reftype=hd res=832.Sizes:elink.
:li. :link reftype=hd res=833.Graphics:elink.
:li. :link reftype=hd res=834.Print:elink.
:li. :link reftype=hd res=835.Set Path:elink.
:li. :link reftype=hd res=836.Edit Function:elink.
:li. :link reftype=hd res=837.Edit Command Text:elink.
:eul.
.*******
:h3 res=831. Fonts
:p.
With this menu the user can change the text font, the graphics font
and the print font. Furthermore the desired font size can be chosen
in lines per screen.
:p.
:nt. For Image fonts (preceded by (I)) size selection will not work 
for all sizes.
:p.
After changing the graphics font, you should call the reset() 
function, so that shrinkwindow() can adjust the screen size porperly.
:ent.
.*******
:h3 res=832. Sizes
:p.
This menu allows the setup of the maximal stack size. However, the
new value will only be applied for the next EULER session. Stack size
can be changed from 1 to 16 MB.
:p.
EULER remembers text output. The size of this memory can be set
from 64k to 1024k.
:p.
If commands are pasted from the clipboard, a memory buffer is used.
The size of this buffer can be set from 64k to 1024k.
:p.
Saving a bitmap can be done in 16 color, 256 color and high color
format. This format can also be chosen here. 4 bit is for 16, 8 bit
for 256 and 24 bit for high color.
.*******
:h3 res=833. Graphics
:p.
Density plots and hue 3D plots can be done with several methods.
Default is using :hp2.log colors:ehp2.. These colors can be dithered,
if they
are not available. If you request pure colors, the system will not use
color dithering. If your screen driver has a palette manager, 
selecting :hp2.color palettes:ehp2. is a good choice. Try it. The 
simplest method is using patterns, since there are only 10 patterns
available.
:p.
The next option is to choose the colors for 3D models. Here, EULER
offers the 16 system colors.
:p.
:hp2.Use Linestyles:ehp2. takes care of a bug in several screen
drivers, which do not display dashed lines. Check it, if your screen
driver does not have this bug.
.*******
:h3 res=834. Print
:p.
The print menu offers the choice of the printer queue. "Default" 
stands for any printer. EULER will use the first one in the queue 
list.
:p.
Next the handling of 3D graphics can be set for the printer. On many 
printers, color representation does not look good. Then you should 
either choose gray and white, or white and white for the two sides
of a 3D surface.
:p.
Also you can set the position of the print on the page. Two
sliders set the vertical and horizontal positions. One slider sets the
size from 20 percent to 100 percent of the page width (resp. height).
The graphics is printed in the same proportions as on the screen.
The size is computed with respect to page width, if the page has
a higher height to width ratio than the plot. Else the size is 
computed with respect to page height. You can determine, if the
output should be clipped to give the same appearance as in the window.
:p.
Finally, it is possible to choose between black lines, text and markers
and colored ones. On most black and white printers color emulation does
not look well.
.************
:h3 res=835. Set Path
:p.
This dialog allows you to control the default paths for the various 
file selectors. You can save these paths, if you choose so.
:p.
Furthermore, the start directory can be set. This can also be done in 
the command line with the "-p path" parameter. This setting will only 
affect the next session, of course.
.*************
:h3 res=836. Edit Text
:p.
This dialog uses the OS/2 multiline editor to let the user enter EULER
commands. You may then choose to discard the input, save it (OK), or 
let the system interpret the lines. In the last case, the content is 
saved to the file AAAA$$$$.E and loaded from there by EULER's load
command.
:p.
It is also possible to load a file or save the content to a file. 
Finally, you may cut and paste into the editor as usual.
:p.
Choosing a function from the list will display that function. Note, 
that functions with default arguments need to be edited before EULER 
will accept them as correct input. The default arguments are printed 
after the function header by internal reasons.
:p.
Good usage of this feature would be the definition of a function. 
Typing a function at the command prompt makes it hard to edit it, and 
calling an external editor to edit a file and the loading it may be to
much trouble for a little function.
:p.
You may also cut old EULER commands from the text window and
paste them to this editor. You can then edit, save or re-run these
commands.
.******************
:h3 res=837. Edit Command Text
:p.
This dialog lets you edit the explanation text of the currenct command.
You may cut and paste into this dialog with the usual commands.
.*********************************************************
:h1 res=200.Using EULER
.*********************************************************
:p.
This section explains the use of the EULER command line, the menu
options and other topics. Available topics are
:ul compact.
:li. :link reftype=hd res=210.Line Editor:elink.
:li. :link reftype=hd res=220.Loading Files:elink.
:eul.
.************************
:h2 res=210.The line editor
:i1.Editing EULER commands
:i1.Keys
:p.
Text can be entered after the prompt (>) using the keyboard. If a letter 
is wrong, it can be cancelled with the :hp2.Backspace:ehp2. key. The
:hp2.cursor keys:ehp2.
-> and <- position the cursor back and forth in the line. The line editor 
is always in insert mode, so any character is inserted at the cursor 
position. :hp2.Pos 1:ehp2. (Home) positions the cursor to the
beginning of
the line, and  :hp2.end:ehp2. to the end of the line.
:hp2.Escape:ehp2. clears
all input. :hp2.Shift:ehp2. plus -> or <- position the cursor one word
to the right
or left. Finally, the input is entered by pressing :hp2.Return:ehp2.. 
Then EULER will start to interpret the command.
:note.The cursor can be at any
position of the input line, when Return is pressed. 
:p.
Previous input can be recalled with the :hp2.cursor-up:ehp2.  and
:hp2.cursor-down:ehp2. keys.  (On the OS/2 notebook version use these keys
with SHIFT).  If a command is recalled this way and entered with Return,
cursor-down recalls the next command; i.e., cursor-up and cursor-down are
always based on the last recalled command.  Clearing the input line also
makes the last command the base for recalling (use :hp2.Escape:ehp2. or
:hp2.Control-Cursor-Up:ehp2.).  Thus Escape plus cursor-up recalls the
previous command.
:p.
The OS/2 notebook interface uses the escape key to end a function 
definition. It will not clear the input line. Use Control-Cursor-Up
instead.
:p.
Pressing the :hp2.Insert:ehp2.  key extends incomplete commands.  Pressing
this key again gives another extension, if there is one.  The search goes
through the command history, the implemented functions, the user defined
functions and the built-in commands in that order.
:p.
There are some other special keys.  The :hp2.Tabulator:ehp2.  key switches
to the Graphics screen and from there any key switches back.  The
:hp2.Escape:ehp2.  key stops any running EULER program and some internal
functions, like the 3-dimensional plots, the linear equation solver and the
polynomial root finder.
:p.
The :hp2.Page-Up:ehp2. and :hp2.Page-Down:ehp2. keys provide a means to 
look at previous output
from EULER. EULER keeps a record of the last 128k of output. When the
command line becomes invisible, pressing any key will make it reappear.
:p.
:i2 refid=expr. ..
Input can spread over several lines by the use of "..". The two dots
are allowed at any place, where a space is acceptable. E.g.
:xmp.    >3+ .. some comment
    >4
:exmp.:p.
is equivalent to
:xmp.    >3+4
:exmp.:p.
Comments can follow the ".." and are skipped.
:p.
The function keys may be programmed by the command
:i2 refid=com. setkey
:xmp.    >setkey(number,"text");
:exmp.:p.
The number must be between 1 and 10 and the "text" may be any EULER
string. Then the corresponding function key will produce the text,
when it is pressed together with the ALT key (since the function keys
are reserved for OS/2).
If the function key text is to contain a ", one
can use char(34) and the EULER string concatenation, as in the example
:xmp.    >setkey(1,"load "|char(34)|"test"|char(34)|";");
:exmp.:p.
which puts
:xmp.    >load "test";
:exmp.:p.
on the :hp2.function key:ehp2. Shift-F1.
.*****************************************************
:h2 res=220.Loading files
:p.
To abbreviate tedious input one may generate a file containing EULER
input. This file can be generated with any editor. To load
that file enter
:i2 refid=com. load
:i2 refid=com. comment
:i2 refid=com. endcomment
:xmp.    >load "filename"
:exmp.:p.
All lines of that file are then interpreted just as any other input
from the keyboard. Also a loaded file may itself contain a load command.
If an error occurs, the loading is stopped and an error message is
displayed. There is a default extension ".e", which you should use for
your files. You need not specify this extension in the load command.
:p.
The best use of a load file is to define functions in that file.
:note. EULER files should have the extension .E (e.g., DEMO.E).
:p.
A file may contain a comments. Comments look like this
:xmp.comment
This is a comment.
Comments can spread several lines.

Also empty lines are allowed.
endcomment
:exmp.:p.
endcomment must be the first string of a line.
:p.
You can turn comment printing off with
:xmp.comment off
:exmp.:p.
Otherwise all comments in a file are displayed, when the file is loaded.
:xmp.comment on
:exmp.:p.
turns this feature on.
.**********************************************************
:h1 res=300.Computing with EULER
:p.
This sections explains EULER expressions etc., but omits programming
aspects. Available topics are
:ul compact.
:li. :link reftype=hd res=310.Data Types:elink.
:li. :link reftype=hd res=320.Commands, Expressions,
Assignments:elink.
:li. :link reftype=hd res=330.Expression Syntax:elink.
:li. :link reftype=hd res=340.Basic Built-in Functions:elink.
:li. :link reftype=hd res=380.Interval Arithmetic:elink.
:li. :link reftype=hd res=390.Exact Scalar Product:elink.
:li. :link reftype=hd res=344.Linear Algebra:elink.
:li. :link reftype=hd res=345.Epsilon:elink.
:li. :link reftype=hd res=349.Optimization:elink.
:li. :link reftype=hd res=350.Statistic Functions:elink.
:li. :link reftype=hd res=360.Polynomials:elink.
:li. :link reftype=hd res=370.Graphics:elink.
:eul.
.*****************************************
:h2 res=310.The Data Types
:p.
:i1.Data Types
EULER uses the following :hp2.data types:ehp2.&colon.
:ul compact.
:li. real numbers
:li. complex numbers
:li. real matrices
:li. complex matrices
:li. strings
:li. real intervals
:li. real interval matrices
:li. references
:li. functions
:eul.
:p.
The meaning of the first five data types should be clear. EULER tries
to keep an evaluation real. But as soon, as complex data is involved
the computation gets complex. That is why
:xmp.    >sqrt(-1)
:exmp.:p.
results in a wrong answer, but
:xmp.    >sqrt(complex(-1))
:exmp.:p.
is 0+1*i. complex(x) is a way to make a real number complex. 
:p.
:hp2.Strings:ehp2. are used for explaining output, file names, passing 
functions to functions, expression strings and function key texts.  There
are only two some operators, like the concetanation | and the compare
operators.
:p.
:hp2.References:ehp2. are used internally for parameters of functions (see
the programming section).
:p.
:hp2.Functions:ehp2. are the user defined functions including the functions
in UTIL. 
:p.
All these data are kept on the :hp2.stack:ehp2.. Usually, the user does not
have
to worry about the stack, since EULER uses normal mathematical notation
for expressions. Internally, the evaluation of an expression uses the
stack rather heavily. Programs are kept in the lower area of the stack.
The stack is also used to pass parameters to built-in or user defined
functions and to keep the local variables of these functions.
:p.
Finally, we remark that the data explained in this section are
different from :hp2.built-in functions:ehp2. which can be used in the same
places
as user defined functions. There are also :hp2.commands:ehp2., which cannot
be used in expressions. Built-in functions and commands are part of the
code of EULER.
:p.
A complete list of built-in functions, commands and user defined
functions is printed by
:i2 refid=com. list
:xmp.    >list
:exmp.:p.
A list of all variables can be obtained with
:i2 refid=com. listvar
:xmp.    >listvar
:exmp.:p.
If size information is needed, the command
:i2 refid=com. memorydump
:xmp.    >memorydump
:exmp.:p.
is available. A hexdump of any data can be obtained with
:i2 refid=com. hexdump
:xmp.    >hexdump name
:exmp.:p.
but it will only be useful for insiders.
:i2 refid=com. store
:xmp.    >store("filename")
:exmp.:p.
stores the content of the EULER stack into a file.
:i2 refid=com. restore
:xmp.    >restore("filename")
:exmp.:p.
loads that file. This is a short way of storing a session including
the global variables and functions.
.*********************************************************
:h2 res=320. Commands, Expressions, Assignments
:p. Explains the basic input types, such as
:ul compact.
:li. :link reftype=hd res=321.Commands:elink.
:li. :link reftype=hd res=322.Expressions:elink.
:li. :link reftype=hd res=323.Assignments:elink.
:li. :link reftype=hd res=324.Multiple Assignments:elink.
:eul.
.*******
:h3 res=321. Commands
:p.
:i1 id=com. Commands and Functions
EULER input is either a "command", an "expression" or an "assignment".
:p.
An example for a :hp2.command:ehp2. is
:i2 refid=com. quit
:xmp.    >quit
:exmp.:p.
which quits the EULER system. By and by, we will mention a few others.
Another example is "load".
.***********
:h3 res=322. Expressions
:i1 id=expr. Expressions
:p.
An :hp2.expression:ehp2. is a valid EULER expression, which has a resulting
value. If it is entered on its own or followed by a ",", this value
is printed.
:xmp.    >3+4*5
:exmp.:p.
prints the value 23.00000. The print is surpressed, if the expression
is followed by a ";". This makes
sense, since some functions have side effects and their result is not
needed, or since the user does not want to see the long output of
an assignment.
:p.
The printing is done with a format determined by the function
:i2 refid=com. format
:xmp.    >format([n,m])
:exmp.:p.
where n is the total width of print and m is the number of digits after
the decimal dot.
:xmp.    >format(n,m)
:exmp.:p.
does the same thing, but is a little bit slower since it is a function
in UTIL. The output automatically switches to exponential format, if
there is not enough space to display the number in fixed format.
There is also the command
:xmp.    >goodformat(n,m)
:exmp.:p.
which does ommit decimal digits, if they are zero.
:i2 refid=com. goodformat
:i2 refid=com. longformat
:i2 refid=com. shortformat
:i2 refid=com. expformat
:i2 refid=com. fixedformat
:i2 refid=com. iformat
:xmp.    >longformat()
:exmp.:p.
is a function in UTIL, which sets a longer output format, while
:xmp.    >shortformat()
:exmp.:p.
sets a shorter one. Both use goodformat.
:p.
You can specify to have exponential format or fixedformat with
:xmp.    >expformat(n,m)
    >fixedformat(n,m)
:exmp.:p.
The format of goodformat command will switch between exponential and 
fixed format.
:p.
For intervals, you may use
:xmp.    >iformat(n)
:exmp.:p.
This will print as many digits as necessary to show the differences
between left and right interval bounds. The output width will be at least 
n.
:xmp.    >iformat(0)
:exmp.:p.
switches back to the usual format.
.*********
:h3 res=323. Assignments
:p.
:i1 id=ass. Assignments
An :hp2.assignment:ehp2. looks like
:i2 refid=ass. =
:xmp.    >variablename=value
:exmp.:p.
The variable name must start with an alphanumeric, and continue with 
alphanumeric characters or digits.  The command assigns the value to
the variable, which is declared by the assignment, and prints the 
value.  If the assignment is followed by a ";", then the printing is 
surpressed.  An assignment may be followed by ",", which prints the 
right hand side of the assignment.  
.**********
:h3 res=324. Multiple Assignments
:p.
:i2 refid=ass. {...}=
The syntax is of a :hp2.multiple assignment:ehp2. is
:xmp.    >{x,y,...}=expression
:exmp.:p.
This does make sense only in cases, when the expression is the result
of
a function with multiple values. If a multiple expression is assigned to
a single variable, only the first value is used.
.***********************************************************
:h2 res=330.Expression Syntax
:p.
Describes the syntax of EULER expressions. E.g.,
:ul compact.
:li. :link reftype=hd res=331.Basic Expressions:elink.
:li. :link reftype=hd res=332.Submatrix:elink.
:li. :link reftype=hd res=333.Strings:elink.
:li. :link reftype=hd res=334.&colon. Operator:elink.
:li. :link reftype=hd res=335.Matrix Expressions:elink.
:li. :link reftype=hd res=336.Generating a Matrix:elink.
:li. :link reftype=hd res=337.Matrix Functions:elink.
:eul.
.*********************
:h3 res=331. Basic Expressions
:p.
:i2 refid=expr. Variables
The most simple expressions are :hp2.variables:ehp2.. Their value is the
value of the variable, and their type is the type of the variable. If the
variable is undefined, interpreting the expressions will stop with
an error message.
:p.
:i2 refid=expr. Constants, Real and Complex
The basic :hp2.constant expressions:ehp2. are :hp2.numbers:ehp2.. Those
are entered in
the usual form 100, 100.0, 1e2, or 1.0e+2. The letter "small e" indicates
powers of 10. An appendix "i" indicates multiples of the :hp2.complex:ehp2.
unit "i". "1+1i" is in fact a sum of 1 and 1i.
:p.
:i2 refid=expr. Matrix Constants
A :hp2.matrix:ehp2. is entered in the brackets "[" and "]" row by row. 
The columns are seperated by "," and the rows by ";". Example&colon.
:xmp.    >A=[1,2,3;4,5;6]
:exmp.:p.
This is equivalent with
:xmp.    >A=[1,2,3;4,5,0;6,0,0]
:exmp.:p.
The matrix is real, if all entries are real, otherwise it is complex.
If an entry of a matrix is an interval, the matrix becomes an interval
matrix.
:p.
If a row is shorter than the others, it is filled with zeros. A matrix
constant can spread over several lines.
:p.
One can also use a 1xn matrix as part of another matrix, like in
:xmp.    >x=[1,2,3,4]
    >A=[7,x]
:exmp.:p.
A will be [7,1,2,3,4] then.
.**************
:h3 res=332. Submatrices
:p.
:i2 refid=expr. Submatrix
A :hp2.submatrix:ehp2. is a matrix, which is made up by the entries of
another matrix. The simplest example is a matrix element
:xmp.    >A[1,1]
:exmp.:p.
which is the element in the first row and column of A. Note, that
submatrices can be assigned values. Thus
:xmp.    >A[1,1]=4.5
:exmp.:p.
is a legal statement. If a submatrix gets complex, the matrix gets
complex. If v is a 1xN or Nx1 matrix (i.e., a vector), then v[1] is
the first element of v; i.e.,
:xmp.    >v=[1.5,-2,0,4.8]; v[3]
:exmp.:p.
is 0. Let us assume now that A is a matrix and r and c are
vectors. Then A[r,c] results in a matrix, which consists of the rows
r[1],r[2],... of A, and from these rows, only the columns c[1],c[2],...
are taken. Example&colon.
:xmp.    >A[[1,2],[1,2]]
:exmp.:p.
is the upper left 2x2 submatrix of A. If a row or column does not
exist, it is simply neglected. Thus, if A is a 4x4 matrix, then
A[[4,7],[4,7]] results in the value A[4,4]. A special thing is A[1],
which is the first row of A. To be precise, if only one index is
present, then the second index is assumed to be "&colon.". A "&colon."
indicates all rows or columns; i.e., A[&colon.,1] is the first column of A,
and A[&colon.,&colon.] is A itself. Another example&colon.
:xmp.    >v=[-1,-2,-3,-4,-5]; v[[5,4,3,2,1,1]]
:exmp.:p.
is the vector [-5,-4,-3,-2,-1,-1]. If A is a 4x4 matrix, then
A[[2,1]] is a 2x4 matrix, which consists of the second row of A on
top of the first row. Note, that there may be a 0xN or Nx0 matrix.
:p.
For compatibility reasons, the square brackets can be replaced by
round brackets. Thus, A(1,1) is the same thing as A[1,1]. But
A[1,1] is faster. Furthermore, if there is a function A, then A(1,1)
will result in a function call to A.
:p.
A{i} is the i-th element of the matrix A, as if the NxM Matrix A
was a vector of length N*M. This is useful for making functions
work for matrices, and is really the quickest way to access a matrix
element. It works also, if the matrix A is to small or a real or
complex scalar variable. Then the result is the last element of A.
:p.
.********************
:h3 res=333. Strings
:p.
:i2 refid=expr. Strings
String constants are enclosed in double quotes, like in
:xmp.    >string="This is a text"
:exmp.:p.
or in two single quotes to make it possible to include quotes in
strings
:xmp.    >string=''This is a "text"''
:exmp.:p.
The section on the line editor shows how to insert a double quote into
a string. A single character with ASCII code n can be produced by
:i2 refid=com. char
:xmp.    >char(n)
:exmp.:p.
.**************************
:h3 res=334. The &colon. Operator
:p.
The "&colon." serves to generate a vector quickly. Thus
:i2 refid=expr. &colon.
:xmp.    >1&colon.10
:exmp.:p.
generates the vector [1,2,3,4,5,6,7,8,9,10]. A step size may be given
as in the example
:xmp.    >5&colon.-1.5&colon.1
:exmp.:p.
which yields [5,3.5,2]. By numerical reasons, one cannot expect to
hit 1 exactly with 0&colon.0.1&colon.1. However, the program uses the 
internal epsilon to stop generating the vector, so that 0&colon.0.1&colon.1
yields the desired result. By default, the internal epsilon is set so that
even
:xmp.    >0&colon.0.0001&colon.1
:exmp.:p.
works correctly. 
:p.
.********************
:h3 res=335. Matrix Expressions
:i2 refid=expr. |
:i2 refid=expr. _
:p.
If A is a matrix expression (an expression of type matrix), then A'
is the transposed matrix.
:p.
The binary operator "|" puts a matrix aside another; i.e., if A is a
NxM matrix and B is a NxK matrix, then A|B is a Nx(M+K) matrix, which
consists of A left of B. Analogously, A_B puts A atop of B. These
operators work also for numbers, which are treated as 1x1 matrices.
They do even work, if A is a Nx0 or 0xN matrix.
:p.
The mathematical operators +,-,*,/ work as usual for numbers. For matrices
they work elementwise. If a is a number and B a matrix, then a+B or B+a
computes the sum of all elements of B with a. If v is a 1xN vector and A 
an MxN matrix, then v+A adds v to 
each row of A. A+v yields the same result. If v is an Mx1 vector and A an
MxN matrix, then each element of v is added to all elements in the 
corresponding row of A. If v is an Mx1 vector, and w is a 1xN vector, then 
v+w is an MxN matrix, which has the sums of corresponding elements of v and
w as entries (The i-j-th elements is v[i]+w[j]). w+v yields the same 
result.
:p.
Of course, the same rules hold for all other operands and functions of two 
parameters. The reason for these rules will become apparant later on. But 
the guidline is, that one can easily generate tables of functions for 
tables of parameters.
:p.
Of course, -A negates all elements of A.
EULER knows the rule, to compute "*" and "/" before "+" and "-".
One can also write ".*","./" for compatibility reasons. If
A has a different size as B, and neither A or B is a 1x1 matrix or
a number, then A+B results in error.
:p.
Note, that the matrix product is computed with "A.B".
:p.
Of course, one can use the round brackets ( and ) to group expressions
like in
:xmp.    >(1+5)*(6+7^(1+3))
:exmp.:p.
The power operator can be written "^" or "**" (or ".^"). It computes
the power elementwise, like all the other operators. So
:xmp.    >[1,2,3]^2
:exmp.:p.
yields [1,4,9]. The power may also be negative; i.e., the integer
powers of all numbers are defined. For a matrix, inv(A) computes the
inverse of A (not "A^-1"!). Note, that "^" has precedence, so
:xmp.    >-2^2
:exmp.:p.
is -4.
:p.
Comparison of values can be done with >, >=, <, <=, != (not
equal) or == (equal). They result in 1 or 0, where 1 is TRUE. Again,
these operators work elementwise; i.e,
:xmp.    >[1,2,3,4]>2
:exmp.:p.
yields [0,0,1,1].
:p.
:xmp.    >!A
:exmp.:p.
(not A) is a matrix, which is 1 on all zero elements of A, and 0 on
all nonzero elements of A. 
:xmp.    >A &amp.&amp. B
:exmp.:p.
is a matrix, which is 1 whenever the corresponding elements of A
and B are nonzero. 
:xmp.    >A || B
:exmp.:p.
is 1 whenever the corresponding element of A is nonzero or the
corresponding element of B is nonzero.
:i2 refid=com. any
:xmp.    >any(A)
:exmp.:p.
yields 1 if any element of A is nonzero.
:p.
One can change dimensions of a matrix with
:i2 refid=com. redim
:xmp.    >B=redim(A,[n,m])
:exmp.:p.
or
:xmp.    >B=redim(A,n,m)
:exmp.:p.
This will copy the content of A to B filling with 0 if necessary. A
matrix is stored row by row.
.*****************************
:h3 res=336.Generating Matrices
:p.
There are several built-in functions which generate matrices. The most
elementary ones are zeros([N,M]) and ones([N,M]), which can also be
written zeros(N,M) and ones(N,M). They produce a NxM matrix, which is
filled with ones or zeros respectively. The input for
zeros and ones is the output of the "size" function, which is [N,M]
for size(A), if A is an NxM matrix. Note, that one can also generate
0xN and Nx0 matrices. So
:i2 refid=com. zeros
:xmp.    >zeros[0,5]_v_v
:exmp.:p.
is a legal statement, if v is a 1x5 vector.
.*****************************
:h3 res=337. Matrix Functions
:p.
:xmp.    >size(A)
:exmp.:p.
returns the size of the matrix A as a 1x2 vector [n,m].
It is also possible to give size several arguments. Then 
:i2 refid=com. size
:xmp.    >size(A,B,...)
:exmp.:p.
results in the size of the largest matrix of A,B,... However, all
matrixes in the list must have the same size, unless their size is
1x1. The use of this feature will become apparent later on. Also
:i2 refid=com. cols
:i2 refid=com. rows
:xmp.    >cols(A)
    >rows(A)
:exmp.:p.
return the number of columns and rows of a matrix A.
:i2 refid=com. length
:xmp.    >length(A)
:exmp.:p.
it the maximum of the number of columns and rows.

More generally,
:i2 refid=com. matrix
:xmp.    >matrix([N,M],x)
:exmp.:p.
or matrix(N,M,x) returns a NxM matrix filled with x, which may be real
or complex.
:p.
:i2 refid=com. diag
:xmp.    >diag([N,M],K,v)
:exmp.:p.
produces a NxM matrix, which has the vector v on its K-th diagonal and
is 0 everywhere else. If v is not long enough, the last element of v
is taken for the rest of the diagonal. The 0-th diagonal is the main
diagonal, the 1-st the one above, and the -1-st the one below. So
:xmp.    >diag([5,5],0,1)
:exmp.:p.
produces the 5x5 identity matrix. The same can be achieved with
:i2 refid=com. id
:xmp.    >id(5) 
:exmp.:p.
from UTIL. One can also write diag(N,M,K,v), as this is defined in UTIL.
:xmp.    >diag(A,K)
:exmp.:p.
is a vector, which is the K-th diagonal of A.
:p.
:i2 refid=com. dup
:xmp.    >dup(v,N)
:exmp.:p.
duplicates the 1xM vector N times, such that a NxM matrix is generated,
which has v in each row. If v is an Mx1 vector, then v is duplicated
into the N columns of a MxN matrix. dup works also, if v is a number.
Then it generates a column vector.
:i2 refid=com. band
:xmp.    >B=band(A,N,M)
:exmp.:p.
sets all elements of A[i,j] to 0, unless N <= i-j <= M.
:i2 refid=com. setdiag
:xmp.    >B=setdiag(A,N,v)
:exmp.:p.
sets the N-th diagonal of A to v. v may be a number or a vector.
:i2 refid=com. bandmult
:xmp.    >bandmult(A,B)
:exmp.:p.
multiplies to matrices A and B (like A.B), but is considerably faster,
if A and B contain lots of zeros.
:i2 refid=com. symmult
:xmp.    >symmult(A,B)
:exmp.:p.
multiplies symmetric matrices A and B and saves half of the time.
:p.
Furthermore,
:i2 refid=com. flipx
:xmp.    >flipx(A)
:exmp.:p.
flips the matrix, such that the last column becomes the first, the first
column the last.
:i2 refid=com. flipy
:xmp.    >flipy(A)
:exmp.:p.
does the same to the rows.
.**************************************************
:h2 res=340. Basic Built-in Functions
:p.
In this section some basic built-in functions are explained. Topics are
:ul compact.
:li. :link reftype=hd res=341.Basic Functions:elink.
:li. :link reftype=hd res=342.Min, Max etc.:elink.
:li. :link reftype=hd res=343.Sum, Proc etc.:elink.
:li. :link reftype=hd res=3431.Rounding:elink.
:li. :link reftype=hd res=3432.String Functions:elink.
:li. :link reftype=hd res=3433.Wait, Timer etc.:elink.
:eul.
:h3 res=341. Basic Functions
:p.
There are the usual functions&colon.
:i2 refid=com. abs
:i2 refid=com. sqrt
:i2 refid=com. exp
:i2 refid=com. log
:i2 refid=com. sin
:i2 refid=com. cos
:i2 refid=com. tan
:i2 refid=com. asin
:i2 refid=com. acos
:i2 refid=com. atan
:i2 refid=com. re
:i2 refid=com. im
:i2 refid=com. conj
:xmp.abs, sqrt, exp,
log, sin, cos,
tan, asin, acos,
atan, re, im, conj.
:exmp.:p.
They all work for complex values. In this case they yield the
principle value. There are some functions which make sense only
for real values&colon.
:i2 refid=com. floor
:i2 refid=com. ceil
:i2 refid=com. sign
:i2 refid=com. fak
:i2 refid=com. bin
:xmp.floor, ceil, sign,
fak, bin.
:exmp.:p.
floor and ceil give integer approximations to a real number. "bin(n,m)"
computes the binomial coefficient of n and m.
:i2 refid=com. pi
:xmp.    >pi()
:exmp.:p.
(or simply ">pi") is a built-in constant.
:i2 refid=com. mod
:xmp.    >mod(x,y)
:exmp.:p.
return x modulus y.
.********************************
:h3 res=342. Max, Min etc.
:p.
:i2 refid=com. max
:xmp.    >max(x,y)
:exmp.:p.
and min(x,y) return the maximum (minimum resp.) of x and y.
:i2 refid=com. min
:i2 refid=com. totalmax
:i2 refid=com. totalmin
:xmp.    >max(A)
:exmp.:p.
and min(A) return a column vector containting the maxima (minima resp.)
of the rows of A. The functions totalmax and totalmin from UTIL
compute the maximum about all elements of a matrix.
:p.
If A is a NxM matrix, then
:i2 refid=com. extrema
:xmp.    >extrema(A)
:exmp.:p.
is a Nx4 matrix, which contains in each row a vector of the form
[min imin max imax], where min and max are the minima and maxima of
the corresponding row of A, and imin and imax are the indices, where
those are obtained.
:p.
If v is a 1xN vector, then
:i2 refid=com. nonzeros
:xmp.    >nonzeros(v)
:exmp.:p.
returns a vector, containing all indices i, where v[i] is not zero.
Furthermore,
:i2 refid=com. count
:xmp.    >count(v,M)
:exmp.:p.
returns a 1xM vector, the i-th component of which contains the number
of v[i] in the interval [i-1,i).
:i2 refid=com. find
:xmp.    >find(v,x)
:exmp.:p.
assumes that the elements of v are ordered. It returns the index (or
indices, if x is a vector) i  such that v[i] <= x < v[i+1], or 0 if
there is no such i.
:i2 refid=com. sort
:xmp.    >sort(v)
:exmp.:p.
sorts the elements of v with the quicksort algorithm. It returns the sorted
vector and the rearranged indices. If
:xmp.    >{w,i}=sort(v);
:exmp.:p.
then v[i] is equal to w.
:p.
.*************************************
:h3 res=343. Sum, Prod etc.
:p.
If A is NxM matrix
:i2 refid=com. sum
:xmp.    >sum(A)
:exmp.:p.
returns a column vector containing the sums of the rows of A.
Analoguously,
:i2 refid=com. prod
:xmp.    >prod(A)
:exmp.:p.
returns the products.
:i2 refid=com. cumsum
:xmp.    >cumsum(A)
:exmp.:p.
returns a NxM matrix containing the cumulative sums of the columns of A.
:i2 refid=com. cumprod
:xmp.    >cumprod(A)
:exmp.:p.
works the same way. E.g.,
:xmp.    >cumprod(1&colon.20)
:exmp.:p.
returns a vector with the faculty function at 1 to 20.
.************************************
:h3 res=3431. Rounding
:p.
:i2 refid=com. round
:xmp.    >round(x,n)
:exmp.:p.
rounds x to n digits after the decimal dot. It also works for complex
numbers. x may be a matrix.
.*********************************
:h3 res=3432. String Functions
:p.
The only string functions in EULER are
:i2 refid=com. stringcompare
:xmp.    >stringcompare("string1","string2")
:exmp.:p.
which returns 0, if the strings are equal, -1 if string1 is
alphabetically prior to string2, and 1 else,
and the comparation operators ==, <, >, <=, >=.
:p.
Besides this, you can concatenate strings with |.
:p.
Furthermore,
:xmp.    >interpret("expression");
:exmp.:p.
will interpret the expression and return the result of the evaluation.
.**************************************
:h3 res=3433. Timer, Wait etc.
:p.
:i2 refid=com. time
:xmp.    >time()
:exmp.:p.
returns a timer in seconds. It is useful for benchmarks etc.
:i2 refid=com. wait
:xmp.    >wait(n)
:exmp.:p.
waits for n seconds or until a key was pressed. It returns the
actual wating time in seconds.
:i2 refid=com. key
:xmp.    >key()
:exmp.:p.
waits for a keypress and returns the internal scan code.
.*****************************************************
:h2 res=380.Interval Arithmetic
:i1. Interval arithmetic
:p.
EULER contains an interval arithmetic. Intervals are number ranges
instead of single numbers. Intervals
are entered in the form
:xmp.    >~a,b~
:exmp.:p.
or
:xmp.    >interval(a,b)
:exmp.:p.
which stands for [a,b], whenever a and b are two reals or real vectors. If
a matrix contains an interval, the matrix will become an interval matrix.
Complex intervals are not yet implemented.
:p.
You may also use the notation
:xmp.    >~x~
:exmp.:p.
if x is a real or a real matrix. However, in this case EULER computes
a small interval with nonempty interior, which contains x. Thus
~x,x~ is different from ~x~!
:p.
If x is alread of interval type, ~x~ will be identical to x.
:p.
You can do all basic and most other operations on intervals. E.g.
:xmp.   >~1,2~ * ~2,3~
:exmp.:p.
is the interval of all st, where s in [1,2] and t in [2,3]. Thus [2,6].
An operation on one or several intervals results
in an interval, which is guaranteed to contain all the possible results,
if the operations is performed on members of the intervals.
:p.
Some operations do not give the smallest possible interval. I traded
speed for accuracy (e.g. sin and cos). However, they will give reasonable
intervals for small input. Some functions do not work for interval 
input.
:p.
Special functions are
:xmp.   >left(x)
:exmp.:p.
and
:xmp.   >right(x)
:exmp.:p.
which give the right and left end of an interval.
:xmp.   >middle(x)
:exmp.:p.
is its middle point and
:xmp.   >diameter(x)
:exmp.:p.
its diameter. Note, that this is not equal to the diameter of a 
product of intervals. To the diameter of an interval vector, use
:xmp.   >sqrt(sum(diameter(x)^2))
:exmp.:p.
The function
:xmp.   >expand(x,f)
:exmp.:p.
will expand an interval x, such that the diameter becomes f times bigger.
If x is non-interval and real, it will produce an interval with midpoint x 
and diameter 2*f.
:p.
You can, check if an interval is contained in another
interval, using
:xmp.   >x << y
:exmp.:p.
This will return true (1), if the interval x is properly contained in
the interval y.
:xmp.   >x <<= y
:exmp.:p.
tests for proper containment or equality.
:p.
You can intersect to intervals with
:xmp.   >x &amp.&amp. y
:exmp.:p.
unless the intersection is empty. This would yield an error. The 
function
:xmp.   >intersects(x,y)
:exmp.:p.
tests for empty intersection.
An interval containing the union of x and y is constructed
with 
:xmp.   >x || y
:exmp.:p.
.*****************************************************
:h2 res=390.Exact Scalar Product
:i1. Exact Scalar Product
:p.
Sometimes it is necessary to compute with higher accuracy. E.g., the 
solution of a linear system A.x=b can be improved by computing the residuum
r=A.x-b and iterating with x=x-A\r. However, this makes sense only if the 
residuum is computed with higher accuracy. You can do this in Euler with
:i2 refid=expr. residuum
:xmp.    >r=residuum(A,x,b)
:exmp.:p.
The result is exact up to the last digit. Just enter 0 for b, if
you just want A.x.
:p.
The computation is done using a long accumulator. This is about 10 times 
slower than A.x-b. You can access the accumulator (two of them for complex 
values and intervals) with
:xmp.    >accuload(v)
:exmp.:p.
for any vector v. This will exactly compute sum(v). The accumulator is not 
cleared afterwards. You can add another vector with
:xmp.    >accuadd(v)
:exmp.:p.
Likewise,
:xmp.    >accuload(v,w); accuadd(v1,w1),
:exmp.:p.
will compute the scalar product of v and w and the scalar product of v1 and
w1. These functions return the last value of the accumulator. You can get 
the complete accumulator into a vector with
:xmp.    >h=accu();
:exmp.:p.
(or accure, accuim, accua, accub for complex accus and intervals). sum(h) 
will then be the value of the accumulator.
.*****************************************************
:h2 res=344.Doing Linear algebra
:p.
There are lots of built-in functions to perform linear algebra. The
matrix product has already been discussed. The operation
:i2 refid=expr. \
:i2 refid=com. \
:i2 refid=com. xlgs
:xmp.    >A\b
:exmp.:p.
takes a NxN matrix A and a Nx1 vector b and returns the vector x such
that Ax=b. If in
:xmp.    >A\B
:exmp.:p.
B is a NxM matrix, then the systems A\B[&colon.,i] are solved
simultanuously.
An error is issued if the determinant of A turns out to be to small
relative to the internal epsilon.
:p.
There is also a more precise version, which uses a residual iteration.
This usualy yields very good results.
:xmp.    >xlgs(A,b)
:exmp.:p.
You may add an additional maximal number of iterations.
:i2 refid=com. inv
:xmp.    >inv(A)
:exmp.:p.
computes the invers of A. This is a function in UTIL defined as
:xmp.
    >A\id(cols(A))
:exmp.:p.
:p.
There are also more primitive functions, like
:i2 refid=com. lu
:xmp.    >lu(A)
:exmp.:p.
for NxM matrices A. It returns multiple values (see:link reftype=hd 
res=324. Multiple Assignments:elink.) You can assign its return values
to variables with
:xmp.    >{Res,ri,ci,det}=lu(A)
:exmp.:p.
If you use only
:xmp.    >Res=lu(A)
:exmp.:p.
all other output values are dropped. To explain the output of lu, lets
start with Res. Res is a NxM matrix containing the LU-decomposition of
A; i.e., L.U=A with a lower triangle matrix L and an upper triangle
matrix U. L has ones in the diagonal, which are omitted so that L and
U can be stored in Res. det is of course the determinant of A. ri
contains the indices of the rows of Res, since during the algorithm 
the rows may have been swept.  ci is not important if A is
nonsingular.  If A is singular, however, Res contains the result of
the Gauss algorithm.  ri contains 1 and 0 such that the columns with 1
form a basis for the columns of A.
:p.
To make an example
:xmp.    >A=random(3,3);
    >{LU,r,c,d}=lu(A);
    >LU1=LU[r];
    >L=band(LU1,-2,-1)+id(3); R=band(LU1,0,2);
    >B=L.R,
:exmp.:p.
will yield the matrix A[r]. To get A, with must compute the inverse 
permutation r1
:xmp.    >{rs,r1}=sort(r); B[r1]
:exmp.:p.
will be A.
:p.
Once we have an LU-decomposition of A, we can use it to quickly solve
linear systems A.x=b. This is equivalent to A[r].x=b[r], and LU[r] is 
a decomposition of A[r], thus x is equal to
:xmp.    >lusolve(LU[r],b[r])
:exmp.:p.
where LU is the result of lu(LU,r,c,A). There is also a more exact version
:xmp.    >xlusolve(A,b)
:exmp.:p.
wich can be used if A is in LU form. E.g., it works for lower triangular
matrices A. This may be used for exact evaluation if arithmetic 
expressions.
:p.
lu is used by several functions in UTIL. E.g.,
:i2 refid=com. kernel
:xmp.    >kernel(A)
:exmp.:p.
is a basis of the kernel of A; i.e., the vectors x with Ax=0.
:i2 refid=com. image
:xmp.    >image(A)
:exmp.:p.
is a basis of the vectors Ax. You may add an additional value 
parameter eps=... to kernal and image, which replaces
the internal epsilon in these functions. These function normalize
the matrix with
:i2 refid=com. norm
:xmp.    >norm(A)
:exmp.:p.
which returns the maximal row sum of abs(A).
:p.
The primitive function for computing eigenvalues is
:i2 refid=com. charpoly
:xmp.    >charpoly(A)
:exmp.:p.
which computes the characteristic polynomial of A. This is used by
:i2 refid=com. eigenvalues
:xmp.    >eigenvalues(A)
:exmp.:p.
to compute the eigenvalues of A. Then
:i2 refid=com. eigenspace
:xmp.    >eigenspace(A,l)
:exmp.:p.
computes a basis of the eigenspace of l. This function uses kernel, 
and will fail, when the eigenvalue not exact enough.
:i2 refid=com. xeigenvalue
:xmp.    >{l,x}=xeigenvalue(A,l)
:exmp.:p.
will improve the eigenvalue l, which must be a simple eigenvalue.
It returns the improved value l and an eigenvector. You can provide
an extra parameter, which is an approximation of the eigenvector.
:i2 refid=com. eigen
:i2 refid=com. eigen1
:xmp.    >{l,X}=eigen(A)
:exmp.:p.
returns the eigenvalues of A in l and the eigenvectors in X. There is 
an improved but slower version eigen1, which will succeed more often 
then eigen.
:i2 refid=com. jacobi
:xmp.    >jacobi(a)
:exmp.:p.
will use Jacobi's method to compute the eigenvalues of a symmetric 
real nxn matrix a.
.******************************************
:h2 res=345. The Internal Epsilon
:p.
:i2 refid=com. epsilon
:i2 refid=expr. ~=
:xmp.    >epsilon()
:exmp.:p.
is an internal epsilon, used by many functions and the operator ~=
which compares two values and returns 1 if the absolute difference is
smaller than epsilon. This epsilon can be changed with the statement
:i2 refid=com. setepsilon
:xmp.    >setepsilon(value)
:exmp.:p.
.*******************************************************
:h2 res=349.Optimization
:i2 refid=com. simplex
:i1. Optimization
:p.
EULER has a built in Simplex algorithm, which minimizes c'*x among all
x, satisfying x>=0 and A*x<=b.
:xmp.    >simplex(A,b,c)
:exmp.:p.
will compute the solution x. To check for feasibility and boundedness,
use
:xmp.    >{x,r}=simplex(A,b,c)
:exmp.:p.
r will be 0, if x is a correct minimum. If r is -1, the problem is not 
feasible. If r is 1, the problem is unbounded. In this case, x contains
a feasible point. In any case A must be a real mxn matrix, b an mx1
matrix (a column vector), and c a 1xn matrix (a row vector). x will
be a nx1 column vector.
:p.
Note, that the internal epsilon is used for numerical computations.
.*******************************************************
:h2 res=350.Statistical functions
:p.
EULER supports statistical functions, such as distribution integrals
and random variables.
:p.
First of all,
:i2 refid=com. random
:xmp.    >random(N,M)
:exmp.:p.
or random([N,M]) generates an NxM random matrix with uniformly
distributed values in [0,1]. It uses the internal random number
generator of ANSI-C. The quality of this generator may be doubtful;
but for most purposes it should suffice. The function
:i2 refid=com. normal
:xmp.    >normal(N,M)
:exmp.:p.
or normal([N,M]) returns normally distributed random variables with
mean value 0 and standart deviation 1. You should scale the function
for other mean values or deviations.
:p.
A function for the mean value or the standart deviation has not been
implemented, since it is easily defined in EULER; e.g,
:xmp.    >m=sum(x)/cols(x)
:exmp.:p.
is the mean value of the vector x, and
:xmp.    >d=sqrt(sum((x-m)^2)/(cols(x)-1))
:exmp.:p.
the standart deviation.
:p.
Rather, some distributions are implemented.
:i2 refid=com. normaldis
:xmp.    >normaldis(x)
:exmp.:p.
returns the probability of a normally distributed random variable 
being less than x.
:i2 refid=com. invnormaldis
:xmp.    >invnormaldis(p)
:exmp.:p.
is the inverse to the above function. These functions are only accurate
to about 4 digits. However, this is enough for practical purposes and
an improved version is easily implemented with the Romberg or Gauss
integration method.
:p.
Another distribution is
:i2 refid=com. tdis
:xmp.    >tdis(x,n)
:exmp.:p.
It the T-distrution of x with n degrees of freedom; i.e., the
probability that n the sum of normally distributed random variables
scaled with their mean value and standart deviation are less than x.
:i2 refid=com. invtdis
:xmp.    >invtdis(p,n)
:exmp.:p.
returns the inverse of this function.
:i2 refid=com. chidis
:xmp.    >chidis(x,n)
:exmp.:p.
returns the chi^2 distribution; i.e., the distribution of the sum of
the squares n normally distributed random variables.
:i2 refid=com. fdis
:xmp.    >fdis(x,n,m)
:exmp.:p.
returns the f-distribution with n and m degrees of freedom.
:p.
Other functions have been mentioned above, like bin, fak, count, etc.,
which may be useful for statistical purposes.
.****************************************************************
:h2 res=360.Polynomials
:p.
Describes the way EULER handles polynomials (plus FFT). Available 
Topics are
:ul compact.
:li. :link reftype=hd res=361.Basics:elink.
:li. :link reftype=hd res=362.Interpolation:elink.
:li. :link reftype=hd res=363.Fast Fourier Transform (FFT):elink.
:eul.
.**************
:h3 res=361. Basics
:p.
EULER stores a polynomial a+bx+...+cx^n in the form [a,b,...,c].  This is
different from MatLab.  It can evaluate a polynomial with the Horner scheme
:i2 refid=com. polyval
:i2 refid=com. xpolyval
:xmp.    >polyval(p,x)
:exmp.:p.
where x can be a matrix, of course. If you want a more exact
answer in case of a badly conditioned polynomial, you may use
:xmp.    >xpolyval(p,x)
:exmp.:p.
You may add an additional maximal number of iterations. This function uses 
the exact scalar product for a residual iteration.
:p.
It can multiply polynomials with
:i2 refid=com. polymult
:xmp.    >polymult(p,q)
:exmp.:p.
or add them with
:i2 refid=com. polyadd
:xmp.    >polyadd(p,q)
:exmp.:p.
Of course, the polynomials need not have the same degree.
:i2 refid=com. polydiv
:xmp.    >polydiv(p,q)
:exmp.:p.
divides p by q and returns {result,remainder}.
:i2 refid=com. polytrunc
:xmp.    >polytrunc(p)
:exmp.:p.
truncates a polynomial to its true degree (using
:link reftype=hd res=345.epsilon:elink.). In UTIL
:i2 refid=com. polydif
:xmp.    >polydif(p)
:exmp.:p.
is defined. It differentiates the polynomial once. To construct a
polynomial with prescribed zeros z=[z1,...,zn]
:i2 refid=com. polycons
:xmp.    >polycons(z)
:exmp.:p.
is used. The reverse is obtained with
:i2 refid=com. polysolve
:xmp.    >polysolve(p)
:exmp.:p.
This function uses the Bauhuber method, which converges very stably
to the zeros. However, there is always the problem with multiple zeros
destroying the accuracy (but not the speed of convergence). Another
problem is the scaling of the polynomial, which can improve the
stability and accuracy of the method considerably.
.*******************
:h3 res=362. Interpolation
:p.
Polynomial interpolation can be done by
:i2 refid=com. interp
:xmp.    >d=interp(t,s)
:exmp.:p.
where t and s are vectors. The result is a polynomial in divided
differences (Newton) form, and can be evaluated by
:i2 refid=com. interpval
:xmp.    >interpval(t,d,x)
:exmp.:p.
at x. To transform the Newton form to the usual polynomial form
:i2 refid=com. polytrans
:xmp.    >polytrans(t,d)
:exmp.:p.
may be used.
.***********
:h3 res=363. Fast Fourier Transform (FFT)
:p.
Interpolation in the roots of unity can be done with
the fast Fourier transform
:i2 refid=com. ifft
:xmp.    >p=ifft(s)
:exmp.:p.
Then p(exp(2*pi*i*k/n))=s[k+1], 0<=k<n-1. For maximal speed, n should
be a power of 2. The reverse evaluates a polynomial at the roots of
unity simultanuously
:i2 refid=com. fft
:xmp.    >s=fft(p)
:exmp.:p.
Note, that polynomials have the lowest coefficient first.
.***************************************************
:h2 res=370.Graphics with EULER
Describes the graphic section of the program. Available topics are
:ul compact.
:li. :link reftype=hd res=371.Basics:elink.
:li. :link reftype=hd res=372.2D Plots:elink.
:li. :link reftype=hd res=373.Titles, Text:elink.
:li. :link reftype=hd res=374.Plot Styles:elink.
:li. :link reftype=hd res=375.Marker Plots:elink.
:li. :link reftype=hd res=376.3D Plots:elink.
:li. :link reftype=hd res=377.Contour and Density Plots:elink.
:li. :link reftype=hd res=378.Function Plots:elink.
:li. :link reftype=hd res=379.The EULER meta file:elink.
:eul.
.***************
:h3 res=371. Basics
:p.
The best part of EULER is its graphic capability. There are two
screens, the text screen and the graphic screen. Text output
automatically displays the text screen, and graphic output displays
the graphic screen. One may also switch to the graphic screen by
pressing TAB on input or with the command
:i2 refid=com. shg
:xmp.    >shg;
:exmp.:p.
There are two coordinate systems. The screen coordinates are a
1024x1024 grid with (0,0) in the upper left corner. Furthermore, each
plot generates plot coordinates mapping a rectangle of the plane on
the screen with the smallest x value left and the smallest y value at
the bottom. To be precise, the rectangle is mapped to the screen
window, which may only cover a part of the display area. See below for
more information on windows.
.***********
:h3 res=372. 2D Plots
:p.
If x and y are 1xN vectors, the function
:i2 refid=com. plot
:xmp.    >plot(x,y)
:exmp.:p.
connects the points (x[i],y[i]) with straight lines and plots these
lines. It first clears the screen and draws a frame around the screen
window. The plot coordinates are chosen such that the plot fits
exactly into the screen window. This behaviour is called autoscaling.
You can set your own plot coordinates with
:i2 refid=com. setplot
:xmp.    >setplot(xmin,xmax,ymin,ymax)
:exmp.:p.
(or setplot([...])). The autoscaling is then turned off. To turn it on
again, use
:xmp.    >setplot()
:exmp.:p.
:i2 refid=com. scaling
:xmp.    >scaling(flag)
:exmp.:p.
will stop (flag=0) or resume (flag=1) the autoscaling of the next plot.
If scaling is off, then the plot region of the last plot (or the one set 
with setplot) is used.
:p.
By the way, the plot command returns the plot
coordinates; i.e., a vector [xmin,xmax,ymin,ymax].
:p.
The screen window is a rectangle on the screen which can be set by
:xmp.    >window(cmin,cmax,rmin,rmax)
:exmp.:p.
(or window([...])) in screen coordinates.
:p.
If x is a 1xN vector and A MxN matrix,
:xmp.    >plot(x,A)
:exmp.:p.
plots several functions. The same is true with
:xmp.    >plot(B,A)
:exmp.:p.
if B is a MxN matrix. In this case, the plot is done for corresponding
rows of A and B.
:p.
The graphic screen is cleared by the plot command. This can be turned
off with
:xmp.    >hold on;
:exmp.:p.
or
:xmp.    >holding(1);
:exmp.:p.
To turn holding off,
:xmp.    >hold off;
:exmp.:p.
or
:xmp.    >holding(0);
:exmp.:p.
is used. The function holding returns the old state of the holding
flag. This is a way to draw several plots into the same frame.
Combining window and holding is a way to draw several plots in several
windows on the screen.
:p.
:i2 refid=com. xplot
:xmp.    >xplot(x,y)
:exmp.:p.
works like plot but does also show axis grids. Actually, xplot has
default parameters grid=1 and ticks=1, which determine, if a grid is
plotted and axis laballing is done. Thus
:xmp.    >xplot(x,y,1,0)
:exmp.:p.
does no ticks. Also
:xmp.    >xplot(x,y,ticks=0)
:exmp.:p.
may be used for the same purpose (see below in the section about EULER
programming for details on
:link reftype=hd res=415.default parameters:elink.).
:xmp.    >xplot()
:exmp.:p.
plots the axis and ticks only.
:p.
You may set vertical to 1, if you wish vertical
axis labels for the y-axis. You should call shrinkwindow again after doing
so, because you will not need so much space to the left of the picture now.
Put the command into EULER.CFG to make it permanent (after loading UTIL).
However, this does make sense only if you have chosen a small outline font like
(O)Courier at about 40 lines per page.
:xmp.    >xplot(z)
:exmp.:p.
will plot xplot(re(z),im(z)), if z is a complex vector.
:i2 refid=com. cplot
:xmp.    >cplot(z)
:exmp.:p.
ca be used to plot a grid pattern, if z is a complex matrix.
:i2 refid=com. histogram
:xmp.    >histogram(data,n)
:exmp.:p.
will plot a histogram of the data distribution. It will divide the 
interval into n equally spaced parts and plot the number of d[i] in
each subinterval.
:p.
You should use
:xmp.    >shrinkwindow()
:exmp.:p.
if you intend to use labels (ticks) on the axis. This leaves some
space around the plot.
:i2 refid=com. fullwindow
:xmp.    >fullwindow()
:exmp.:p.
resizes the plots to the full size. You may also set the x axis grids
on your own with
:i2 refid=com. xgrid
:xmp.    >xgrid([x1,x2,x3,...])
:exmp.:p.
or
:i2 refid=com. ygrid
:xmp.    >xgrid([x1,x2,x3,...],f)
:exmp.:p.
the latter producing digits at the edge of the plot (ygrid(...) works
respectively). Actually, these functions are defined in UTIL.
:p.
To plot with logarithmic scale is not straightforward. Assume the data is 
t=1&colon.100 and s=1&colon.100. You first plot
:xmp.    >plot(t,log(s))
:exmp.:p.
Then you set the grid for both axes manually.
:xmp.    >xgrid(100&colon.100&colon.1000); 
    >ticks=2^(0&colon.9); ygrid1(log(t),t);
:exmp.:p.
So xgrid sets grids at 100,200,...,1000 and ygrid1 sets ticks at the
logarithms of 2,4,8,..,512 but using the labels 2,4,8,...,512 instead of 
the actual logarithmic values. This scheme allows for any scaling, not only
for logarithmic.
:p.
:i2 refid=com. plotarea
:xmp.    >plotarea(x,y)
:exmp.:p.
sets the plot area for the next plot like plot(x,y), but it does not
actually plot.
:i2 refid=com. reset
:xmp.    >reset
:exmp.:p.
is a function in UTIL, which calls shrinkwindow, hold off and some
other stuff to reset the plot coordinates to default values.
.***********
:h3 res=373. Titles and Plot Text
:p.
:i2 refid=com. title
:xmp.    >title("text")
:exmp.:p.
draws a title above the plot. It is a function in UTIL using
:i2 refid=com. text
:i2 refid=com. ctext
:i2 refid=com. rtext
:i2 refid=com. vtext
:i2 refid=com. vctext
:i2 refid=com. vrtext
:xmp.    >ctext("text",[col,row])
:exmp.:p.
which plots the text centered at screen coordinates (col,row).
:xmp.    >text("text",[col,row])
:exmp.:p.
plots the text left justified. The width and height of the charcters can
be asked with
:i2 refid=com. textsize
:xmp.    >textsize()
:exmp.:p.
returning the vector [width,height] in screen coordinates. There is
also
:xmp.    >rtext("text",[col,row])
:exmp.:p.
which alignes text to the right. Vertical text can be printed with
:xmp.    >vtext("text",[col,row]);
:exmp.:p.
:i2 refid=com. vutext
:i2 refid=com. vcutext
:i2 refid=com. vrutext
vctext would center the text vertically, and vrtext would allign it 
at text end. The functions vutext, vcutext and vrutext work the same 
way with text going from bottom up.
.*********
:h3 res=374. Plot Styles and Colors
:p.
If a color monitor is used, EULER can produce colored plots. The plot
color can be modified with
:i2 refid=com. color
:i2 refid=com. framecolor
:i2 refid=com. textcolor
:xmp.    >color(n)
:exmp.:p.
where n=1 is black, and n=0 is white. Other colors depend on your
system settings. The textcolor and framecolor can be set the same way.
:p.
There is the possibility to use dotted and dashed lines, or even
invisible lines erasing the background. This is done with
one of the commands
:i2 refid=com. style
:xmp.    >style(".")
    >linestyle(".")
:exmp.:p.
("-","--","i"). The function linestyle, also
:i2 refid=com. linestyle
:xmp.    >linestyle("")
:exmp.:p.
returns the previous line style. The lines can have a width greater than
0. This is set with
:i2 refid=com. linewidth
:xmp.    >linewidth(n)
:exmp.:p.
The function returns the previous setting.
.***********
:h3 res=375. Marker Plots
:p.
The command
:i2 refid=com. mark
:xmp.    >mark(x,y)
:exmp.:p.
works like plot. But it does not connect the points but plots single
markers at (x[i],y[i]). The style of the marker can be set with one
of the commands
:i2 refid=com. markerstyle
:xmp.    >style("mx")
    >markerstyle("mx")
:exmp.:p.
for a cross. Other styles are "m<>" for diamonds, "m." for dots, "m+"
for plus signs, "m[]" for rectangles and "m*" for stars. The function
returns the previous marker style.
:xmp.    >style("")
:exmp.:p.
resets the plot and marker styles. There is also the command
:i2 refid=com. xmark
:xmp.    >xmark(x,y)
:exmp.:p.
which works like xplot.
.************
:h3 res=376. 3D Plots
:p.
The easiest way to produce 3D-plots is
:i2 refid=com. mesh
:xmp.    >mesh(Z)
:exmp.:p.
If Z is a NxM matrix, its elements are interpreted as z-values of a
function defined on a grid of points (i,j). The plot is a three
dimensional plot with hidden lines of the points (i,j,Z[i,j]). It is
autoscaled to fit onto the screen window. The point (1,1,z[1,1]) is
the front left point. To improve the look of the plot, one can use
:i2 refid=com. triangles
:xmp.    >triangles(1)
:exmp.:p.
However, this way is considerably slower. Of course,
:xmp.    >triangles(0)
:exmp.:p.
turns this feature off again. One can also turn off the different fill
styles mesh uses for the two sides of the plot with
:i2 refid=com. twosides
:xmp.    >twosides(0)
:exmp.:p.
This function works also for solid plots described below. It is a faster
way than the use of triangles to avoid seeing the errors, that the 
mesh plot
frequently makes. By the way, both functions return the old values of
the flags.
:p.
There is a function which produces matrices X and Y such that X[i,j]
and Y[i,j] are the coordinates in the plane of a point in a
rectangular grid parametrized by (i,j). This function is
:i2 refid=com. field
:xmp.    >{X,Y}=field(x,y)
:exmp.:p.
where x and y are row vectors. Then X[i,j] is equal to x[i] and Y[i,j]
is equal to y[j]. So you can easily generate a matrix of function
values; e.g.,
:xmp.    >Z=X*X+Y*Y
:exmp.:p.
However, you can do this more easily, by defining y as a column vector,
x as a row vector. Then
:xmp.    >Z=x*x+y*y
:exmp.:p.
will work just as expected. This is due to the rules for operand, which
operate on matrices. Even a more complex expression, like x*y+3*x+y^3 
would be evaluated correctly.
:p.
A nicer way to plot a surface is
:i2 refid=com. solid
:xmp.    >solid(x,y,z)
:exmp.:p.
or
:i2 refid=com. framedsolid
:xmp.    >framedsolid(x,y,z)
:exmp.:p.
where x, y and z are NxM matrices. The surface parameters are then
(i,j) and (x[i,j],y[i,j],z[i,j]) are points on the surface. The
function would work, if x is a row vector, y a column vector,
just as an operator.
:p.
The
surface should not self intersect; or else plot errors will occur. The
surface is projected onto the screen in central projection, with the
view centered to (0,0,0). You can set the viewing distance, a zooming
parameter, the angles of the eye from the negative y- to the positive
x-axis, and the height of the eye on the x-y-plane, by
:i2 refid=com. view
:xmp.    >view(distance,tele,angle,height)
:exmp.:p.
(or view([...])). view returns the previous values and view() merely
returns the old values. framedsolid has a default parameter scale,
which scales the image to fit into a cube with side length 2*scale,
centered at 0, unless scale=0, which is the default value (no
scaling). Thus
:xmp.    >framedsolid(x,y,z,2)
:exmp.:p.
will scale the plot so that |x|,|y|,|z|<=2.
:i2 refid=com. wire
:xmp.    >wire(x,y,z)
:exmp.:p.
and
:i2 refid=com. framedwire
:xmp.    >framedwire(x,y,z)
:exmp.:p.
work the same way, but the plotting is not solid. If x, y and z are
vectors, then a path in three dimensions is drawn. The color of the
wires is set by
:i2 refid=com. wirecolor
:xmp.    >wirecolor(c)
:exmp.:p.
If you add an extra value to framedwire or framedsolid like in
:xmp.    >framedwire(x,y,z,scale)
:exmp.:p.
the plot is scaled to fit into a cube of side length 2*scale. The
function
:i2 refid=com. project
:xmp.    >{x1,y1}=project(x,y,z)
:exmp.:p.
projects the coordinates x,y,z to the screen and is useful for 3D
path plots. There is a function
:i2 refid=com. sclematrix
:xmp.    >scalematrix(A)
:exmp.:p.
which scale the matrix A linearly so that its entries are between
0 and 1.
:xmp.    >solid(x,y,z,i)
:exmp.:p.
is a special form of solid. If i=[i1,...,in], then the ij-th row
of (x,y,z) is not connected to the ij+1-st row. I.e., the plot
consists of n+1 parts.
.*************
:h3 res=377. Contour and Density Plots
A contour plot of a matrix is produced by
:i2 refid=com. contour
:xmp.    >contour(A,[v1,...,vn])
:exmp.:p.
The contour lines are then at the heights v1 to vn. The interpretation
of A is the same as in mesh(A).
:p.
A density plot is a plot of a matrix, that uses shades to make the
values visible. It is produced with
:i2 refid=com. density
:xmp.    >density(A)
:exmp.:p.
The integer part of the values is cut off. So the shades run through
the available shades, if A runs from 0 to 1. A can be scaled to 0 to
f with
:xmp.    >density(A,f)
:exmp.:p.
f=1 is the most important value. The shades can be controlled with
:i2 refid=com. huecolor
:xmp.    >huecolor(color)
:exmp.:p.
Any positive color produces shades in that color with varying intensity.
The color 0 uses a rainbow color scheme.
:i2 refid=com. solidhue
:xmp.    >solidhue(x,y,z,h)
:exmp.:p.
makes a solid view with shades. h are the shading values as in density.
:i2 refid=com. framedsolidhue
:xmp.    >framedsolidhue(x,y,z,h,scale,f)
:exmp.:p.
works like a mixture of framedsolid and solidhue. scale=0 and f=1 are
the default values.
.*********
:h3 res=378. Plotting a Function
:p.
The plotting of a user defined function f(x,...) can be done with
:i2 refid=com. fplot
:xmp.    >fplot("f",a,b)
    >fplot("f",a,b,n)
    >fplot("f",a,b,,...)
:exmp.:p.
The extra parameters ... are passed to f. n is the number of
subintervals. Note the extra ',', if n is omitted. If a and b
are omitted, as in
:xmp.    >fplot("f",,,,...)
:exmp.:p.
or
:xmp.    >fplot("f")
:exmp.:p.
then the plot coordinates of the last plot are used. 
:p.
You can use an expression instead of a function name.
:xmp.    >fplot("x^2",-1,1)
:exmp.:p.
This will plot te function x^2 on the interval [-1,1].
:p.
You can zoom in with the mouse by
:i2 refid=com. setplotm
:xmp.    >setplotm(); fplot("f");
:exmp.:p.
This lets you select a square region of the screen. In any case,
setplotm() sets the plot coordinates to the user selected square.
:h3. Choosing Coordinates with the Mouse
:p.
It is possible to sample coordinates from the graphics screen with
the mouse.
:i2 refid=com. mouse
:xmp.    >mouse()
:exmp.:p.
displays the graphics screen and a mouse pointer and waits for a mouse
click. It returns a vector [x,y] which are the plot coordinates of the
clicked spot. Using
:i2 refid=com. select
:xmp.    >{x,y}=select()
:exmp.:p.
returns several x coordinates and y coordinates at the points, which
the user selected by the mouse. The selection stops, if the user clicks
above the plot window.
:p.
A 3D-plot can be done with
:xmp.    >f3dplot("f")
:exmp.:p.
f can be a function name of a function f(x,y), or an expression in x and y.
Additional parameters are
:xmp.    >f3dplot("f",xmin,xmax,ymin,ymax,nx,my)
:exmp.:p.

.*******************************************************
:h2 res=379.The EULER meta file
:p.
For special purposes, you can keep a record of your graphic output
on an external file called meta file. You turn on recording with
:i2 refid=com. meta
:xmp.    >meta "filename";
:exmp.:p.
and turn it off again with
:xmp.    >meta;
:exmp.:p.
:p.
The content of the meta file looks like this. All commands start with
a command number (a byte) and the number of arguments (a byte). Then
several arguments follow (int or long or a string). The screen
coordinates are multiplied by 1000 and are stored long, as is hue
and scale. Note that int may be 16-bit or 32-bit depending on
your machine.
:xmp.  1 c0 r0 c1 r1 color style width
:exmp.:p.
  Draws a line from (c0,r0 to (r1,c1). The style is none=0, solid=1,
  dotted=2, dashed=3.
:xmp.  2 c r color type
:exmp.:p.
  A marker at (c,r). dot=0, plus=1, start=2, square=3, cross=4,
  diamond=5.
:xmp.  3 n c1 r1 f1 c2 r2 f2 c3 r3 f3 ... cn rn style
:exmp.:p.
  A filled rectangle with the specified corners. fill style is solid=0,
  dotted=1. The corners are (ci,ri) and fi is a flag which determines
  if the point is to be connected to the next one on the boundary. n
  is the number of points.
:xmp.  4 c r color centered Text+0(+0)
:exmp.:p.
  A text at (c,r). The extra 0 makes the text have an even length.
:xmp.  5 scale
:exmp.:p.
  scales the plot window to 1 : (scale/1024). A 0 means rescaling
  to full screen.
:xmp.  6
:exmp.:p.
  clears the screen.
:xmp.  7 c1 r1 c2 r2 hue color
:exmp.:p.
  Draws a rectangle with upper left corner (c1,r1) and lower right
  corner (c2,r2). hue is a value from 0 to 1 multiplied by 1000.
  color is as in the function huecolor().
:xmp.  8 c1 r1 c2 r2 c3 r3 c4 r4 hue color
:exmp.:p.
  Draws a filled polygon with corner (ci,ri).
:xmp.  9 c r color centered Text+0(+0)
  10 c r color centered Text+0(+0)
:exmp.:p.
  A vertical text at (c,r). The extra 0 makes the text have an even
length. 
:p.
Meta files are used internally to redraw the graphics.
:p.
The author has no use for external meta file right now. But clearly
someone
might write a program for printer output, film sequences etc. using
the meta file. Sorry, but I was unable to use POSTSCRIPT commands. It
should be trival to translate the above commands however.
:p.
Note, that the OS/2 version contains a meta file output in the form
of a OS/2 meta file.
.******************************************************
:h1 res=400.Programming EULER
.******************************************************
:p.
Explains the EULER programming language and its use.
:ul compact.
:li. :link reftype=hd res=410.EULER Functions:elink.
:li. :link reftype=hd res=420.Program Flow:elink.
:li. :link reftype=hd res=430.Debugging:elink.
:li. :link reftype=hd res=440.Porgramming Style:elink.
:li. :link reftype=hd res=450.Functions as Parameters:elink.
:li. :link reftype=hd res=460.User Interface:elink.
:eul.
.******
:h2 res=410.EULER functions
:p.
Explains the basics on EULER functions and their parameters. Subtopics
are
:ul compact.
:li. :link reftype=hd res=411.Defining Functions:elink.
:li. :link reftype=hd res=412.Global Variables:elink.
:li. :link reftype=hd res=413.Parameter by Reference:elink.
:li. :link reftype=hd res=414.Variable Parameter Number:elink.
:li. :link reftype=hd res=415.Default Values:elink.
:li. :link reftype=hd res=416.Returning Multiple Values:elink.
:li. :link reftype=hd res=417.Function Comments:elink.
:eul.
.**********
:h3 res=411. Defining Functions
:p.
:i1 id=pro. Programming Language
EULER would not be as powerful as it is, if there wasn't the
possibility to extend it with :hp2.user defined functions:ehp2.. A function
can be entered from the keyboard or better from a file. Since there
may be errors in a function, it is best to call an editor, edit the
function in a file and then load that file. In the OS/2 version, you 
might use the internal editor.
:p.
Loading a file is done with
:xmp.    >load "filename"
:exmp.:p.
A function is declared by the following commands
:i2 refid=pro. function
:xmp.    >function name (parameter,...,parameter)
    >...
    >endfunction
:exmp.:p.
It can have several parameters or none. If the function is entered
from the keyboard, the prompt changes to "$". "endfunction"
finishes the function definition. An example&colon.
:xmp.    >function cosh (x)
    $  return (exp(x)+exp(-x))/2
    $endfunction
:exmp.:p.
Every function must have a return statement, which ends the execution
of the function and defines the value it returns. A function can be
used in any expression, just as the built-in functions. If a function
is not used in an assignment and with surpressed output (followed by
";"), it is used like a procedure and its result is evidently lost.
However, the function may have had some side effect.
.***********
:h3 res=412. Global Variables
:p.
Inside a function one cannot access :hp2.global variables:ehp2. or 
variables
of the function which called the function. To use global variables use
the command
:i2 refid=pro. global
:i2 refid=pro. useglobal
:xmp.    >global variablename
:exmp.:p.
in the function body. Of course, one can use other functions in
expressions inside a function, one can even use the function inside
itself :hp2.recursively:ehp2.. All variables defined inside a function are
:hp2.local:ehp2. to that function and undefined after the return from the
function.
There is no way to define global variables or change the type or size
of global variables from within a function, even if one defines these
variables in a "global" statement.
:p.
:xmp.    >useglobal
:exmp.:p.
lets you access all global variables from inside the function. This is only
valid for the function containing the useglobal command.
.**********
:h3 res=413. Parameter by Value or Reference?
:caution.Variables are passed as :hp2.references:ehp2..
:p.
That means that a change
of a parameter results in the change of the variable, which was
passed as the parameter. For example
:xmp.    >function test(x)
    $  x=3;
    $  return x
    $endfunction
    >a=5;
    >test(a);
    >a
:exmp.:p.
prints the value 3. There is an exeption to this. A :hp2.submatrix:ehp2. is
passed :hp2.by value:ehp2.. Thus
:xmp.    >a=[1,2,3];
    >test(a(1));
    >a(1)
:exmp.:p.
prints the value 1.
.**********
:h3 res=414. Variable Parameter Number
:p.
:i2 refid=pro. argn
:i2 refid=pro. args
A function can have a variable number of parameters. The number of
parameters passed to a function can be determined with the built-in
function "argn()". If the parameters are not named in the function
definition, they are given the names arg1, arg2 and so on.
:p.
You can access the parameters from the n-th parameter on with args(n).
This functions returns multiple values (argn,...) and these values
may be passed to another function as several parameters. 
p.
args() will return all paremeters from the first non-named parameter.
These additional parameters may be passed to a function.  If the
parameter list in the function call contains a semicolon (;), args()
will return all parameters after the semicolon.
.**********
:h3 res=415. Default Values for Parameters
:p.
Parameters can have default values. The syntax ist parameter=value in
the parameter definition; e.g.,
:xmp.    >function f(x=3,y,z=1&colon.10)
:exmp.:p.
assigns the default value 3 to x and the vector 1 to 10 to z, if the
function is called in the form
:xmp.    >f(,4,)
:exmp.:p.
If the function is called
:xmp.    >f(1,4)
:exmp.:p.
x has the value 1, y the value 4, and z the value 1&colon.10.
:p.
The function can even be given a named parameter. Consider the
function
:xmp.    >function f(x,y,z=4,w=4,t=5)
:exmp.:p.
Then
:xmp.    >f(1,2,t=7)
:exmp.:p.
calls the function, as if
:xmp.    >f(1,2,4,4,7)
:exmp.:p.
was entered. Actually the name needs not be a parameter name. Thus
:xmp.    >f(1,2,s=7)
:exmp.:p.
defines a local variable s with value 7.
.************
:h3 res=416. Returning Multiple Values
:p.
A function can return multiple values. This is done with the return
statement
:xmp.    >  return {x,y,...}
:exmp.:p.
You can assign all the return values of a function to variables, using
:xmp.    >{a,b,...}=function(...);
:exmp.:p.
If the result of such a function is assigned to a number of variables
smaller than the number of returned values, only the first values are
used. If is is assigned to a larger number of variables, the last value
is used more than once. Some built-in functions return multiple values.
.*********
:h3 res=417. Function Comments
:p.
Comments can be included, starting with ##. Comments are not entered
in the function definition and do not appear, when you type the
function with
:xmp.    >type functionname
:exmp.:p.
If the lines immediately after the function header start with ##,
then those lines are considered to be help text. They can be displayed
with
:xmp.    >help functionname
:exmp.:p.
This is a good way to remember the parameters of the function. Also
:xmp.    >list
:exmp.:p.
can be used to display the names of the user defined functions.
:p.
A function or several functions can be removed with
:i2 refid=pro. forget
:xmp.    >forget name,...
:exmp.:p.
By the way, a variable can be removed with
:i2 refid=pro. clear
:xmp.    >clear name,...
:exmp.:p.
.************************************************************
:h2 res=420. Program flow
.************************************************************
:p.
Like in any other programming language, in EULER there are commands
for changing the flow of evaluation. These commands can only be used
inside user defined functions.
:p.
First there is the "if" command.
:i2 refid=pro. if
:i2 refid=pro. then
:i2 refid=pro. else
:xmp.    >if expression; ...;
    >else; ....;
    >endif;
:exmp.:p.
The expression is any EULER numerical expression. If it is a matrix,
and all its entries are different from zero, then the part from the
";" to the "else;" is evaluated. Else the part from "else;" to "endif"
is evaluated. Of course "..." may spread over several lines. To work
correctly, keywords like "if", "else", "endif" and others should be
the first nonblank characters in a line, or should be preceded by "," or
";" (plus blanks or TABs). The "else" may be omitted. In this case the
evaluation skips behind the "endif", if the matrix contains nonzero
elements (resp. the number is nonzero).
:p.
You may also include one or several elseif commands
:xmp.    >if expression; ...;
    >elseif expression; ...;
    >else; ....;
    >endif;
:exmp.
This is the same as an if command inside the else part. However, you
do not have to type several endifs.
:p.
There is the function "any(A)", which yields 1, if there is any
nonzero element in A, 0 otherwise. The function is useful in
connection with the if statement.
:p.
Next, there are several loops.
:i2 refid=pro. repeat
:i2 refid=pro. end
:i2 refid=pro. loop
:i2 refid=pro. for
:i2 refid=pro. step
:xmp.    >repeat; ...; end;
    >loop a to b; ...; end;
    >for i=a to b step c; ...; end;
:exmp.:p.
All loops can be aborted by the break command (usually inside an
"if"), especially the seemingly infinite "repeat". "loop" loops are
fast long integer loops. The looping index can be accessed with the
function "index()" or with "#". In a "for" loop the looping index is
the variable left of the "=". The step size can be omitted. Then it is
assumed to be 1. As an example, the following loops count from 1 to
10&colon.
:xmp.    >  i=1;
    >  repeat;
    >    i, i=i+1;
    >    if i>10; break; endif;
    >  end;
:exmp.:p.
and
:xmp.    >  loop 1 to 10; #, end;
:exmp.:p.
and
:xmp.    >  for i=1 to 10; i, end;
:exmp.:p.
.****************************************************
:h2 res=430.Debugging EULER programs
.****************************************************
:p.
The command
:i2 refid=pro. trace
:i1. Tracing
:xmp.    >trace on
:exmp.:p.
sets tracing of all functions on. Then any new line in a user defined
function will be printed with the function name before it is executed.
The uses has to press a key, before execution continues&colon.
:ul compact.
:li.  Control-F1    debugs every function.
:li.  Control-F2    debugs no function called in the current line.
:li.  Control-F3    will stop debugging until return of the current
function. 
:li.  Control-F4    will prompt for an expression and evaluate it.
:li.  Control-F9    aborts execution of the program.
:li.  Control-F10   ends tracing for this command.
:eul.:p.
Any other key will display the available keys. Note that the help key 
is mapped to the insert key on a PC.
:xmp.    >trace off
:exmp.:p.
switches tracing off.
:p.
Note, that with F4 you can evaluate any expression, even if it contains
local variables or subroutine calls. Tracing is switched off during
evaluation of the expression.
:p.
A single function can be traced with
:xmp.    >trace function
:exmp.:p.
or
:xmp.    >trace "function"
:exmp.:p.
Execution will stop only in this function. The same command switches
the trace bit of this function off.
:xmp.    >trace alloff
:exmp.:p.
switches tracing for all functions off.
.************************************************
:h2 res=440.Programming style
.************************************************
:p.
All internal EULER functions can handle vector or matrix input. And so
should user defined functions. To achieve this, sometimes nothing
special needs to be done. E.g., the function
:xmp.    >function kap (r,i,n)
    >  p=1+i/100;
    >  return p*r*(p^n-1)/(p-1)
    >endfunction
:exmp.:p.
is automatically capable to handle matrix intput. Thus
:xmp.    >kap(1000,5&colon.0.1&colon.10,10)
:exmp.:p.
will produce a vector of values. However, if the function uses a more
complicated algorithm, one needs to take extra care. E.g.,
:xmp.    >function lambda (a,b)
    >  si=size(a,b); l=zeros(si);
    >  A=resize(a,si); B=resize(b,si);
    >  loop 1 to prod(si);
    >    l{#}=max(abs(polysolve([1,A{#},B{#},1])));
    >  end;
    >  return l
    >endfunction
:exmp.:p.
shows the fastest way to achieve the aim. "si" will contain the size,
of the matrix "a" or "b", and will yield an error message, if the
sizes are different. However, if "a" is a real and "b" a matrix, "si"
will contain the size of "b" and the program will still run properly.
Next we expand the matrix such that they have the correct sizes. This is 
necessary, if a is a 1xn vector and b a mx1 vector.
:p.
The loop will then be over all the elements of "a" or "b". the "{#}"
indexing works correctly, if the vector is smaller than the index. It
then yields the last element of a vector, which is OK in the case of a
real or complex values.
:p.
Forthermore, as a matter of good style, one should use the help lines
extensively. One should explain all parameters of the function and its
result. This is a good way to remember what the function really does.
.************************************************
:h2 res=450. Passing functions as parameters
.************************************************
:p.
It is possible to pass functions to a function. E.g., the function
"bisect" in UTIL finds the zero of a function using bisection. One
uses this function in the following way&colon.
:xmp.    >function f(x)
    >  return x*x-2
    >endfunction
    >bisect("f",1,2)
:exmp.:p.
The result will be sqrt(2). If "f" needs extra paramters, those can
also be passed to "bisect"&colon.
:xmp.    >function f(x,a)
    >  return x*x-a
    >endfunction
    >bisect("f",0,a,a)
:exmp.:p.
will result in sqrt(a) (for a>=0). The search interval is set to [0,a].
:p.
The way to write a function like "bisect" is to use the "args" function.
:xmp.    >function bisect (function,a,b)
    >...
    >  y=function(x,args(4));
    >...
    >endfunction
:exmp.:p.
Then "function" will be called with the parameter "x" and all 
parameters
from the 4-th on (if any) which have been passed to "bisect". Of course,
"function" should be assigned a string, containing the name of the
function which we want the zero of.
:p.
Another way to achieve this result is the use of args() without parameter.
This will return all parameters from the first additional parameter on.
If the user calls bisect like this
:xmp.    >bisect ("f",a,b;4,5)
:exmp.:p.
All parameter after the ";" will be passed to function, when it is
called
:xmp.    >y=function(x,args());
:exmp.:p.
.**************************************************
:h2 res=460.User interface
.**************************************************
:p.
Clearly, EULER is designed to run interactively. The user loads a file
containing the functions he needs. The file may inform the user of its
content by simply printing some messages with commands like
:xmp.    >"The content of this file is&colon.",
    >...
:exmp.:p.
Alternatively, the file could contain a comment section.
:xmp.
comment
Any comment!
Even in several lines.
endcomment
:exmp.:p.
Then the user can use the help facility to retrieve further information
on the functions, its parameters and so on. He (or she) then calls the
particular function with the parameters he desires.
:p.
However, it is also possible to run a file as a standalone program.
If you start EULER from a shell simply put the file into the command
line.
:p.
If you wish a standalone application, the user will have to enter data.
You can prompt him with
:i2 refid=com. input
:xmp.    >data=input("prompt");
:exmp.:p.
The prompt
:xmp. prompt? >
:exmp.:p.
will appear and the user may enter any valid EULER expression, even if
it uses variables. Errors are catched and force the user to reenter
the input. If you wish the user to enter a string, use
:i2 refid=com. lineinput
:xmp.    >string=lineinput("prompt");
:exmp.:p.
The string may then be evaluated with
:i2 refid=com. interpret
:xmp.    >data=interpret(string);
:exmp.:p.
and if it does not consist of a valid EULER expression the result is the
string "error". Also
:i2 refid=com. errorlevel
:xmp.    >errorlevel(string)
:exmp.:p.
returns a nonzero number, if there is an error in the string.
:p.
Output is printed to screen. All expressions and assignments produce
output unless followed by ";". If formated output is wanted, use
:i2 refid=com. printf
:xmp.    >printf("formatstring",realdata)
:exmp.:p.
The format string obeys the C syntax; e.g., "%15.10f" prints the data
on 15 places with 10 digits after decimal dot, and "%20.10e" produces
the exponential format. You can concatenate strings with | to longer
output in a single line.
:p.
Output is surpressed globally with
:i2 refid=com. output
:xmp.    >output off;
:exmp.:p.
and
:xmp.    >output on;
:exmp.:p.
turns the output on again. This is useful if a dump file is defined by
:i2 refid=com. dump
:xmp.    >dump "filename";
:exmp.:p.
Then all output is echoed into the dump file. The command
:xmp.    >dump;
:exmp.:p.
turns the dump off. Note that the dump is always appended to the file.
Furthermore, that file may not be edited while dump is on! In UTIL the
function
:i2 refid=com. varwrite
:xmp.    >varwrite(x,"x")
:exmp.:p.
is defined, which writes x in a format readable by EULER on input.
If you omit the name "x", the name of x is used automatically. This
is done with the help of the function
:xmp.    >name(x)
:exmp.:p.
which is a string containing the name of x.
:p.
:i2 refid=com. cls
:xmp.    >cls;
:exmp.:p.
clears the screen.
:i2 refid=com. clg
:xmp.    >clg;
:exmp.:p.
clears the graphics. Also to show graphics to the user, use
:xmp.    >shg;
:exmp.:p.
Subsequent output will switch back to the text screen.
:p.
Finally, an error can be issued with the function
:i2 refid=com. error
:xmp.    >error("error text")
:exmp.:p.
.*************************************
:h1 res=500.Files and Directories
.*************************************
:p.
This section describes some special commands. Available topics are
:ul compact.
:li. :link reftype=hd res=510.Directories:elink.
:li. :link reftype=hd res=520.File Input and Output:elink.
:eul.
.****************************************
:h2 res=510.Directories
:p.
The active directory can be changed with
:i2 refid=com. cd
:i2 refid=com. searchfile
:i2 refid=com. changedir
:xmp.    >cd "path"
:exmp.:p.
where path is the new directory and may include a drive letter, like
:xmp.    >cd "a&colon.\progs"
:exmp.:p.
The changedir function does the same. It will return the active directory
when it is called with "".
:p.
The command
:i2 refid=com. dir
:xmp.    >dir "*.e"
:exmp.:p.
displays all files in the active directory, which fit with the pattern.
An empty string fits all files.
:p.
The function
:xmp.    >searchfile("*.e");
:exmp.:p.
returns files that fit to the pattern until there are no nore files of
this kind. It returns "" then.
.******************
:h2 res=520. File Input and Output
:p.
:i2 refid=com. open
:i2 refid=com. close
:i2 refid=com. putchar
:i2 refid=com. putword
:i2 refid=com. putlongword
:i2 refid=com. getchar
:i2 refid=com. getword
:i2 refid=com. getlongword
:i2 refid=com. getstring
:i2 refid=com. write
:i2 refid=com. getvector
:i2 refid=com. eof
There are some primitive file input and output routines. The normal
method is via :link reftype=hd res=460.dump:elink.. However,
:xmp.    >open("test.dat","w")
:exmp.:p.
will open the file test.dat for writing, erasing it if it exists. The 
two parameters of open must be strings and work just like fopen. So
:xmp.    >open("test.dat","r")
:exmp.:p.
opens the file for reading. Opening in binary mode can be achieved 
with "wb" or "rb". "a" stand for append and will write to the end of 
the file.
:note.  You can only open a single file at any time. Opening a second 
one will close the first one.
:xmp.    >close()
:exmp.:p.
will close the file again.
:xmp.    >putchar(c)
:exmp.:p.
puts a character with code c to a binary file. If c is a 1xn real vector, 
it will put n characters to the file.
:xmp.    >putword(x)
    >putlongword(x)
:p.:exmp.
Puts a word or a vector of words (long words) to the file in binary format.
:xmp.    >c=getchar()
:exmp.:p.
reads a character. 
:xmp.    >v=getchar(n)
:exmp.:p.
reads a vector of n characters.
:xmp.    >x=getword()
    >x=getlongword()
:exmp.:p.
reads a word or long word.
:xmp.    >x=getword(n)
    >x=getlongword(n)
:exmp.:p.
reads n words (long words) from a binary file.
:xmp.    >s=getstring(n)
:exmp.:p.
reads a string of length n from a binary file.
:p.
You can check for the end of the file with
:xmp.    >eof()
:exmp.:p.
It will return 1, if the file is completely read.
:xmp.    >write("string")
:exmp.:p.
is a function, which writes a string to a text file. You can add a
newline with
:xmp.    >write("string"|asc(10))
:exmp.:p.
Often, you have numbers stored in files in a unpredictable format.
You can use
:xmp.    >getvector(n)
:exmp.:p.
to get a vector of these numbers. The functions will read over any
nonumeric data and will stop after reading n numbers. You can use
:xmp.    >{v,m}=getvector(n)
:exmp.:p.
to get the vector v and the actually read numbers m.
.**************************************************
:h1 res=530. Special Problem Solvers
:p.
In UTIL some fuctions are defined, which will to be of general use.
First there are some functions for solving equations.
:i2 refid=com. bisect
:xmp.    >bisect("f",a,b,...)
:exmp.:p.
uses the bisetion method to solve f(x,...)=0. f must be a function
of the real variable x which may have additional parameters "...".
These parameters can be passed to bisect and are in turn passed to f.
You can use the syntax
:xmp.    >bisect("f",a,b;v)
:exmp.:p.
to pass the additional parameter v to f(x,v). This syntax applies to
all functions below, which accept additional parameters to be passed
to a function.
:p.
The method uses the internal epsilon to stop the iteration. You can
specify an own epsilon with
:xmp.    >biscet("f",a,b,eps=0.1)
:exmp.:p.
Note, that parameters with values must be the last parameters of all.
The eps parameter can be applied to many functions in this section.
:p.
It is possible to pass an expression to bisect. This expression must
be a string containing a valid EULER expression for f(x). The name
of the unknown variable must be x.
:xmp.    >bisect("x^2-2",1,2);
:exmp.:p.
All functions in this section will work with expressions in x.
:i2 refid=com. secant
:xmp.    >secant("f",a,b,...)
:exmp.:p.
uses the secant method for the same purpose. "f" may again be an expression
containing the variable x.
:p.
If you want to find the root of an expression, which contains one variable 
or many variables, you can use
:i2 refid=com. root
:xmp.    >root("expr",x)
:exmp.:p.
expr must be any valid EULER expression. All variables in this expression 
must be global variables of type real. This function is not to be used in 
other functions, unless this functions sets the global variables first! x
must be the name of the variable, which you want to solve expr==0 for. The 
new value of x solves the expression. E.g.,
:xmp.    >a=2; x=1; root("x^2-a",x)
:exmp.:p.
will set x equal to sqrt(2).
:p.
The minimum of a comvex function (maximum of a concave function) can be
computed with fmin (fmax). E.g.
:xmp.    >fmin("x^3-x",0,1)
:exmp.:p.
If f is a function, you may also use fmin("f",0,1).
:p.
:i2 refid=com. broyden
:xmp.    >broyden("f",x)
:exmp.:p.
or
:xmp.    >broyden("f",x,J,...)
:exmp.:p.
uses the Broyden method to find the roots of f(x,...)=0. This time, f
may be a function f : R^n -> R^n (n>1). Then x is a vector. J is an
approximation of the Jacobian at x, the starting point. If J==0 or J
is missing, then the function computes J. Again, additional parameters
are passed to f.
:p.
:i2 refid=com. simpson
:xmp.    >simpson("f",a,b)
:exmp.:p.
or
:xmp.    >simpson("f",a,b,n,...)
:exmp.:p.
computes the Simpson integral with of f in [a,b]. n is the discretization
and additional parameters are passed to f(x,...). f must be able to
handle vector input for x. Again, "f" may be an expression in x.
:p.
:i2 refid=com. gauss
:xmp.    >gauss("f",a,b)
:exmp.:p.
or
:xmp.    >gauss("f",a,b,n,...)
:exmp.:p.
performs gauss integration with 10 knots. If n is specified, then
the interval is subdivided into n subintervals. f(x,...) must be able
to handle vector intput for x. "f" may be an expression in x.
:p.
:i2 refid=com. romberg
:xmp.    >romberg("f",a,b)
:exmp.:p.
or
:xmp.    >romberg("f",a,b,n,...)
:exmp.:p.
uses the Romberg method for integration. n is the starting discretization.
All other parameters are as in "simpson". Again, "f" may be an expression
containing the variable x.
:p.
There are some approximation tools. Polynomial interpolation has been
discussed above. There is also spline interpolation
:i2 refid=com. spline
:xmp.    >sp=spline(t,s)
:exmp.:p.
which returns the second derivatives of the natural cubic spline through
(t[i],s[i]). To evaluate this spline at x,
:i2 refid=com. splineval
:xmp.    >splineval(t,s,sp,x)
:exmp.:p.
is available.
:p.
:i2 refid=com. polyfit
:xmp.    >polyfit(t,s,n)
:exmp.:p.
fits a polynomial of n-th degree to (t[i],s[i]) in least square mode.
This is an application of
:i2 refid=com. fit
:xmp.    >fit(A,b)
:exmp.:p.
which computes x such that the L_2-norm of Ax-b is minimal.
:p.
:i2 refid=com. iterate
:i2 refid=com. niterate
:xmp.    >iterate("f",x,...)
:exmp.:p.
seeks a fixed point of f by iterating the function from x. If you
provide additional arguments ..., these are passed to f. Of course,
f must be a function of type
:xmp.    >function f(x)
    $...
    $endfunction
:exmp.:p.
If you want see the iterations, use the following variant.
:xmp.    >niterate("f",x,n,...)
:exmp.:p.
iterates f starting at x n times and returns the vector of iterated
values.
:i2 refid=com. steffenson
:i2 refid=com. nsteffenson
:xmp.    >steffenson("f",x);
:exmp.:p.
Seeks a fixed point starting from f using the Steffenson operator.
nsteffenson is similar to niterate.
:p.
:xmp.    >newton("f","f1",x,...)
:exmp.:p.
finds a zero of f using the Newton method. You must provide the 
derivative of f in f1. Similarily
:xmp.    >newton2("f","Df",x,...)
:exmp.:p.
is used for several parameters. f(x) must compute an 1xn vector y from
the 1xn vector x. Df(x) must compute the nxn derivative matrix at x.
:p.
:i2 refid=com. map
:xmp.    >map("f",x,...)
:exmp.:p.
evaluates the function f(x,...) at all elements of x, if f(x,...)
does not work because the function f does not accept vectors x.
:p.
:i2 refid=com. heun
The only differential equation solver is the Heun method. To use
it, write the function f, which defines the differential equation
y=f(t,y). y can be a 1xN vector. Then call
:xmp.    >heun("f",t,y0,...)
:exmp.:p.
The extra parameters ... are passed to f. y0 is the starting value
y(t[1]) and t must be a vector of points t. The function returns the
values of the solution at t. The accuracy depends of the distances
from t[i] to t[i+1].

.**************************************
:h1 res=915. Interval Solvers
:i1. Interval Procedures
:p.
This file provides some interval procedures, which produce guaranteed 
inclusions.
:p.
:xmp.    >y=idgl("f",x,y0);
:exmp.:p.
y is then an inclusion of the solution of the differential equation 
y'=f(x,y). f is an EULER function with two arguments like
:xmp.    function f (x,y)
        return x*y;
    endfunction
:exmp.:p.
x is a vector of x values, where the solution is to be computed. The 
accuracy will depend on the step size in x. y0 is a starting value for 
y[1]. y is a vector of interval values containing the solution.
:p.
:xmp.    >x=ilgs(A,b);
    >x=ilgs(A,b,R);
:exmp.:p.
This is a linear system solver, producing an inclusion of the solution of 
Ax=b. You may provide a matrix R, which is close to the inverse of A.
The procedure may fail.
:p.
:xmp.    >iinv(A);
:exmp.:p.
This produces an inclusion of the inverse of A.
:p.
:xmp.    >ipolyval(p,t)
:exmp.:p.
This computes an inclusion of the value of the polynomial p at t. t may be 
a vector.
:p.
:xmp.    >inewton("f","f1",~a,b~)
:exmp.:p.
This is the interval Newton method. f must be a function and f1 its
derivative. ~a,b~ is a starting interval, which must contain a zero.
If it does not contain a zero, there will most probably occur an empty
intersection. If the starting interval is replaced by a non-interval
real number, the function calls the Newton method and expands the
result to an interval, which is taken as a starting interval.
Of course, f1 must not be zero in ~a,b~. The function returns the
inclusion interval and a flag, which is nonzero if the interval
is a verified solution.
:p.
This function accepts expressions instead of functions. E.g.
:xmp.    >inewton("x^2-2","2*x",~1,2~);
:exmp.:p.
will compute and inclusion of sqrt(2).
:p.
:xmp.    >newton2("f","f1",x);
    >inewton2("f","f1",x);
:exmp.:p.
newton2 is the Newton method for several dimensions. f must be a function, 
which computes a 1xn vector f(x) from a 1xn vector x. f1(x) must procude 
the Jacobian matrix at x. inewton does the same, but produces an interval 
inclusion. The start interval vector x must contain a solution.

.***********************************
:h1 res=600. Hints
:p.
One can make all sorts of mistakes in EULER. This section tries to
warn you of the more common ones, most os which the author has some
experience with.
:p.
As already mentioned, you should not assign to the parameter of a
function. This will generally produce strange errors, which are
difficult to debug.
:p.
The next mistake is to produce matrices with 0 rows or columns. EULER
can not do any computation with these matrices. Make sure that every
index you use is in range. And use special handling, if there is
nothing to do. However, you may generate such matrices for
the special purpose of appending vectors to it.
:p.
Another subtlety concerns the use of multiple return values. The
following simply does not work&colon.
:xmp.    >x=random(1,10); sin(sort(x))
:exmp.:p.
The reason is that sort returns not only the sorted array but also the
indices of the sorted elements. This works as if sin was passed two
parameters and EULER will not recognize that use of sin. To work
around this either assign the sorted array to a variable or put extra
brackets around it&colon.
:xmp.    >x=random(1,10); sin((sort(x)))
:exmp.:p.
Also a return statement like
:xmp.    >return {sort(x),y}
:exmp.:p.
really returns 3 (or more) values! Use
:xmp.    >return {(sort(x)),y}
:exmp.:p.
:p.
One further misfortune results from the use of strings as functions,
like in
:xmp.    >function test(f,x)
    >    return f(x*x)
    >endfunction
    >test("sin",4)
:exmp.:p.
This works well as long as there is no function by the name of "f". If
there is, this function is called rather than the sine function. The
only way to avoid this is to use really strange names for function
parameters. I prefer "test(ffunction,x)" and used it throughout UTIL.
:p.
Finally, we like to stress that built-in functions are searched before 
the user defined functions. If a built-in function with a matching 
number of arguments exists, it will be called.

.**************************************
:h1 res=900. Included EULER files
:p.
This section explaines some of the *.e files, which are included with 
EULER.
:p.
:ul compact.
:li. :link reftype=hd res=910.demo.e:elink.
:li. :link reftype=hd res=911.util.e:elink.
:li. :link reftype=hd res=912.test.e:elink.
:li. :link reftype=hd res=913.bench.e:elink.
:li. :link reftype=hd res=914.apple.e:elink.
:li. :link reftype=hd res=916.3dplot.e:elink.
:li. :link reftype=hd res=917.bezier.e:elink.
:li. :link reftype=hd res=918.games.e:elink.
:li. :link reftype=hd res=919.hondt.e:elink.
:li. :link reftype=hd res=920.interest.e:elink.
:li. :link reftype=hd res=921.sound.e:elink.
:eul.

.**************************************
:h2 res=910. demo.e
:p.
You probably know this one. Just load it. You can start a selfrunning demo 
with demo(n), where n is a time interval in seconds.
.**************************************
:h2 res=911. util.e
:p.
This file is loaded from EULER.CFG. It contains lots of functions. Most of 
them are (should be) explained in this documentation.

.**************************************
:h2 res=912. test.e
:p.
These are some test suites to test, if your EULER system works correctly.

.**************************************
:h2 res=913. bench.e
:p.
This is a benchmark for EULER. Just run test.

.**************************************
:h2 res=914. apple.e
:i1. Mandelbrot Set
:p.
This is a nice plot of the Mandelbrot apple set and its potential. Just 
load the file.

.**************************************
:h2 res=916. 3dplot.e
:p.
This allows some nice plots of mappings from (x,y) to z. You first 
need to define a function f(x,y), -1 <= x,y <= 1, like
:xmp.    function f(x,y)
        return x*y;
    endfunction
:exmp.:p.
Then you can get plots of it with
:xmp.    >f3d("f");
    >f3dpolar("f");
    >fcontour("f");
:exmp.:p.
In all cases "f" may be a valid EULER expression using x and y (and other 
global variables). This avoids the definition of a function. The function 
f3dplot is contained in UTIL already.

.**************************************
:h2 res=917. bezier.e
:p.
This file computes some Bezier curves and survaces. Some
demo functions are available.
:p.
:hp2.beziertest:ehp2. lets you click at points to define (x,y) values 
and computes and shows the bezier curve to these points. It is based 
on the function :hp2.bezier(p,t):ehp2., which evaluates the Bezier 
curve through the columns of the matrix p in t. 
:hp2.bezier3dtest:ehp2. displays a Bezier curve in 3D-space.
:p.
:hp2.nurbstest:ehp2. shows some quadratic nurbs with increasing weight
in the middle point. It is bases on :hp2.nurbs(p,b,t):ehp2., which 
works like bezier(p,t), but needs a weight vector b.
:p.
:hp2.beziersurftest:ehp2. shows a bezier surface with its determining 
grid of points. :hp2.beziersurf(x,y,z):ehp2. computes the surface. 
x,y,z are the coordinates of the grid points (kxl-matrices).
It returns three values {xb,yb,zb}, which are the coordinates of the 
(n+1)^2 surface points.
:p.
:hp2.c1test:ehp2. is another demo.

.**************************************
:h2 res=918. games.e
:i1. Games
:p.
This computes the optimal strategy for some simple games. Read the 
help for a description of the games (gambling,scissors,poker).
:p.
:hp2.game(A):ehp2. computes the optimal strategy for a game with 
matrix A.

.**************************************
:h2 res=919. hondt.e
:p.
Computes seat distributions for votes.
:p.
:hp2.hondt(v,n):ehp2. and :hp2.best(v,n):ehp2. take the votes for the
parties and the numer of seats as parameters and compute a vector of 
seats for the parties.

.**************************************
:h2 res=920. interest.e
:i1. Interest Rates
:p.
Computes the interest rate of an investment.
:p.
The general purpose functions are :hp2.rate(x):ehp2. or 
:hp2.rate2(x,n):ehp2.. Both compute the interest rate of a payment
vector x, with positive or negative entries. The first function 
assumes times 0,...,n and the latter times n[1],....,n[m].
:p.
:hp2.investment:ehp2. computes the interest rate of an investment with
a start installment, several payments (positive) and a final
installment. See the help for more information.

.**************************************
:h2 res=921. sound.e
:i1. Sound
:p.
With this file, you can load or save mono WAV files in 8 or 16 bit.
:p.
:hp2.v=loadwave(filename):ehp2. loads a WAV file into a vector v.
It does also return the sampling rate r and will save this to the
global variable defaultrate.
:p.
:hp2.savewave(filename,v):ehp2. will save the sound with the 
defaultrate and 8 bits. You may specify the rate and bits as extra 
parameters.
:p.
:hp2.analyze(v):ehp2. does a spectrum decomposition of the sound. the 
full parameter list is :hp2.analyze(v,fmin,fmax,rate,points):ehp2..
fmin and fmax are the minimal and maximal frequencies of interest, 
rate is the sampling rate and points are the number of points to be 
used (should be a power of 2).
:p.
:hp2.mapsound(v):ehp2. does an analysis for the sound at certain time 
increments. It will procude a nice density plot of the frequencies. 
the full parameter list is 
:hp2.mapsound(v,dt,fmin,fmax,simpl,rate):ehp2., where dt is the time
increment in seconds, simp is a simplification factor (take 1), and 
rate is the sampling rate.

.*********************************************************
:euserdoc.

