#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

int wrapping=1,limit=50,linesize=60,linelength=0,indent=0,blank=1,
	defindent=4,line=0,pagelength=50;

void newpage (void)
{   if (line>0)
	{	putchar(12); putchar('\n'); line=0; linelength=0;
	}
}

void expect (int n)
{	if (line+n>pagelength) newpage();
}

void newline (void)
{   if (line>0 || linelength>0)
	{	putchar('\n');
		line++; linelength=0;
	}
	if (line>pagelength) newpage();
}

void emptyline (void)
{	if (linelength>0) newline();
	newline();
	linelength=0;
}

void skipline (void)
{	int c;
	while (1)
	{	c=getchar();
		if (c=='\n' || c==EOF) break;
	}
}

int ampers (void)
{	int c;
	char tag[32];
	int tagn=0;
	while (tagn<31)
	{   c=getchar();
		if (!isalpha(c) && !isdigit(c)) break;
		tag[tagn++]=c;
	}
	tag[tagn]=0;
	while (c!='.')
	{	c=getchar();
		if (c==EOF) break;
	}
	if (!strcmp(tag,"colon")) return ':';
	if (!strcmp(tag,"amp")) return '&';
	return ' ';
}

void header (char u, int centered)
{	char text[256];
	int textn=0;
	int c,s,i;
	emptyline();
	if (centered) newpage();
	else expect(6);
	while (1)
	{	c=getchar();
		if (c!=' ') break;
	}
	while (c!='\n' && c!=EOF)
	{	if (textn<255) text[textn++]=c;
		c=getchar();
		if (c=='&') c=ampers();
	}
	text[textn]=0;
	s=(int)strlen(text);
	if (centered && s<linesize)
	{	for (i=0; i<(linesize-s)/2; i++) putchar(' ');
		puts(text); line++; linelength=0;
		for (i=0; i<(linesize-s)/2; i++) putchar(' ');
		for (i=0; i<s; i++) putchar(u);
		newline();
		newline();
	}
	else
	{	puts(text); line++; linelength=0;
		for (i=0; i<s; i++) putchar(u);
		newline();
		newline();
	}
}

void tag (void)
{	int c;
	char tag[32];
	int tagn=0;
	while (tagn<31)
	{   c=getchar();
		if (!isalpha(c) && !isdigit(c)) break;
		tag[tagn++]=c;
	}
	tag[tagn]=0;
	while (c!='.')
	{	c=getchar();
		if (c=='\'')
			while(1)
			{	c=getchar();
				if (c=='\n' || c=='\'' || c==EOF) break;
			}
		if (c==EOF) break;
	}
	if (!strcmp(tag,"p")) emptyline();
	else if (!strcmp(tag,"li"))
	{	printf("\n - "); linelength=3; indent=3; blank=0;
	}
	else if (!strcmp(tag,"ul")) emptyline();
	else if (!strcmp(tag,"eul"))
	{	indent=0; emptyline();
	}
	else if (!strcmp(tag,"dl")) emptyline();
	else if (!strcmp(tag,"edl"))
	{	indent=0; emptyline();
	}
	else if (!strcmp(tag,"dt"))
	{	printf("\n - "); linelength=3; indent=3; blank=0;
	}
	else if (!strcmp(tag,"dd"))
	{	printf("\n   "); linelength=3; indent=3; blank=0;
	}
	else if (!strcmp(tag,"h1")) header('=',1);
	else if (!strcmp(tag,"h2")) header('=',0);
	else if (!strcmp(tag,"h3")) header('-',0);
	else if (!strcmp(tag,"h4")) header(0,0);
	else if (!strcmp(tag,"h5")) header(0,0);
	else if (!strcmp(tag,"h6")) header(0,0);
	else if (!strcmp(tag,"i1")) skipline();
	else if (!strcmp(tag,"i2")) skipline();
	else if (!strcmp(tag,"xmp")) { expect(2); emptyline(); wrapping=0; }
	else if (!strcmp(tag,"exmp")) { wrapping=1; }
	else if (!strcmp(tag,"artwork"))
	{	emptyline();
		puts("<Artwork>"); line++;
		emptyline();
	}
}

int main (int argc, char *argv[])
{   int c,c1,i;
	if (argc>1)
	{	pagelength=atoi(argv[1]);
	}
	while (!feof(stdout))
	{	c=getchar();
		if (c==EOF) break;
		if (c==':') tag();
		else if (wrapping)
		{   if (c=='&') c=ampers();
			if (c=='\n') c=' ';
			if (c=='.')
			{	c1=getchar();
				if (c1=='*')
				{   emptyline();
					while (c1!='\n' && c1!=EOF)
					{	c1=getchar();
					}
					continue;
				}
				else ungetc(c1,stdin);
			}
			if (c!=' ' && blank && linelength>limit)
			{	newline(); linelength=indent;
				for (i=0; i<indent; i++) putchar(' ');
				putchar(c); linelength++; blank=0;
			}
			else
			{	if (c==' ') blank=1;
				else
				{   if (blank && linelength>indent) putchar(' ');
					putchar(c); linelength++;
					blank=0;
				}
			}
		}
		else
		{	if (c=='&') c=ampers();
			if (c=='\n') newline();
			else putchar(c);
			if (c==' ') blank=1;
			if (c!='\n') linelength++;
		}
	}
	return 0;
}
