#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

FILE *in,*out;

int wrapping=1,limit=50,linelength=0,blank=1,nl=1,nop=0;

void newline (void)
{   if (linelength>0)
	{	putc('\n',out);
		linelength=0;
	}
}

void emptyline (void)
{	if (linelength>0) newline();
	putc('\n',out);
	linelength=0;
}

void skipline (void)
{	int c;
	while (1)
	{	c=getc(in);
		if (c=='\n' || c==EOF) break;
	}
}

int ampers (void)
{	int c;
	char tag[32];
	int tagn=0;
	while (tagn<31)
	{   c=getc(in);
		if (!isalpha(c) && !isdigit(c)) break;
		tag[tagn++]=c;
	}
	tag[tagn]=0;
	while (c!='.')
	{	c=getc(in);
		if (c==EOF) break;
	}
	if (!strcmp(tag,"colon")) return ':';
	if (!strcmp(tag,"amp")) return '&';
	return ' ';
}

void output (char *s, int n)
{	fprintf(out,"%s",s); linelength=n;
}

char name[8][64],value[8][64];
int namen;

void header (int level)
{	char text[256],ref[256]="";
	int textn=0;
	int c,i;
	emptyline();
	while (1)
	{	c=getc(in);
		if (c!=' ') break;
	}
	while (c!='\n' && c!=EOF)
	{	if (textn<255) text[textn++]=c;
		c=getc(in);
		if (c=='&') c=ampers();
	}
	text[textn]=0;
	for (i=0; i<namen; i++)
	{	if (!strcmp(name[i],"res"))
		{	sprintf(ref," name=%s",value[i]);
        }
	}
	if (ref[0])
		fprintf(out,"<H%d><a%s>%s</a></H%d>",level,ref,text,level);
	else fprintf(out,"<H%d>%s</H%d>",level,text,level);
	linelength=10;
	emptyline();
	nop=1;
}

void title (void)
{	char text[256];
	int textn=0;
	int c;
	emptyline();
	while (1)
	{	c=getc(in);
		if (c!=' ') break;
	}
	while (c!='\n' && c!=EOF)
	{	if (textn<255) text[textn++]=c;
		c=getc(in);
		if (c=='&') c=ampers();
	}
	text[textn]=0;
	fprintf(out,"<TITLE>%s</TITLE>",text);
	linelength=10;
	emptyline();
}

void tag (void)
{	int c;
	char tag[32];
	char *p;
	int tagn=0,i;
    namen=0;
	while (tagn<31)
	{   c=getc(in);
		if (!isalpha(c) && !isdigit(c)) break;
		tag[tagn++]=c;
	}
	tag[tagn]=0;
	while (1)
	{	while (c==' ' || c=='\n') c=getc(in);
		if (c=='.') break;
		p=name[namen];
		while (c!='=' && c!='.' && c!='\n' && c!=EOF)
		{	*p++=tolower(c); c=getc(in);
		}
		*p=0;
		if (c!='=') continue;
		c=getc(in);
		if (c=='\'')
		{	p=value[namen];
			c=getc(in);
			while (c!='\n' && c!=EOF && c!='\'')
			{	*p++=tolower(c); c=getc(in);
			}
			*p=0;
			if (c=='\'') c=getc(in);
		}
		else
		{	p=value[namen];
			while (c!='.' && c!='\n' && c!=EOF && c!=' ')
			{	*p++=tolower(c); c=getc(in);
			}
			*p=0;
		}
		namen++;
	}
	if (!strcmp(tag,"p") && !nop)
	{	newline(); output("<P>",3); emptyline();
	}
	else if (!strcmp(tag,"li"))
	{	newline(); output("<LI>",4); blank=0;
	}
	else if (!strcmp(tag,"ul"))
	{	emptyline(); output("\n<UL>",4); newline();
	}
	else if (!strcmp(tag,"eul"))
	{	newline(); output("</UL>",5); emptyline(); nop=1;
	}
	else if (!strcmp(tag,"dl"))
	{	emptyline(); output("\n<DL>",4); newline();
	}
	else if (!strcmp(tag,"edl"))
	{	newline(); output("\n</DL>",5); emptyline(); nop=1;
	}
	else if (!strcmp(tag,"dt"))
	{	newline(); output("\n<DT>",4); blank=0;
	}
	else if (!strcmp(tag,"dd"))
	{	newline(); output("\n<DD>",4); blank=0;
	}
	else if (!strcmp(tag,"h1")) header(1);
	else if (!strcmp(tag,"h2")) header(2);
	else if (!strcmp(tag,"h3")) header(3);
	else if (!strcmp(tag,"h4")) header(4);
	else if (!strcmp(tag,"h5")) header(5);
	else if (!strcmp(tag,"h6")) header(6);
	else if (!strcmp(tag,"title")) title();
	else if (!strcmp(tag,"i1")) skipline();
	else if (!strcmp(tag,"i2")) skipline();
	else if (!strcmp(tag,"xmp"))
	{	emptyline(); output("\n<PRE>",6); wrapping=0;
	}
	else if (!strcmp(tag,"exmp"))
	{	wrapping=1; output("</PRE>",6); wrapping=1; emptyline();
		nop=1;
	}
	else if (!strcmp(tag,"artwork"))
	{	emptyline(); output("<P>",4);
		for (i=0; i<namen; i++)
		{	if (!strcmp(name[i],"name"))
			{   p=value[i];
				while (*p!='.' && *p!=0) p++;
				*p=0;
				fprintf(out,"<IMG SRC=%s.gif><P>\n",value[i]); linelength=4;
				nop=1;
			}
		}
		emptyline();
	}
	else if (!strcmp(tag,"link"))
		for (i=0; i<namen; i++)
		{	if (!strcmp(name[i],"res"))
			{	fprintf(out,"<a href=#%s>",value[i]); linelength+=20;
			}
		}
	else if (!strcmp(tag,"elink"))
	{	fprintf(out,"</a>"); linelength+=4;
	}
}

int main (int argc, char *argv[])
{   int c,c1;
	if (argc==3)
	{	in=fopen(argv[1],"r");
		out=fopen(argv[2],"w");
		if (!in || !out) exit(1);
	}
	else
	{	in=stdin; out=stdout;
	}
	while (!feof(out))
	{	c=getc(in);
		if (c==EOF) break;
		if (c==':') tag();
		else if (wrapping)
		{   if (c=='&') c=ampers();
			else if (c=='<') output("&lt;",4);
			else if (c=='>') output("&gt;",4);
			else if (c=='\n') { c=' '; nl=1; goto blank; }
			else if (nl && c=='.')
			{	c1=getc(in);
				if (c1=='*')
				{   emptyline(); skipline();
					output("<HR>",4); newline();
					continue;
				}
				else ungetc(c1,in);
			}
			else if (c!=' ' && blank && linelength>limit)
			{	newline();
				putc(c,out); linelength++; blank=0;
			}
			else
			{	blank :
				if (c==' ') blank=1;
				else
				{   nl=0;
					if (blank && linelength>0) putc(' ',out);
					putc(c,out); linelength++;
					blank=0;
				}
			}
			if (c!=' ') nop=0;
		}
		else
		{   nop=0;
			if (c=='<') output("&lt;",4);
			else if (c=='>') output("&gt;",4);
			else
			{	if (c=='&') c=ampers();
				putc(c,out);				if (c==' ') blank=1;
				if (c!='\n') linelength++;
				else linelength=0;
			}
		}
	}
	if (argc==2)
	{	fclose(in);
		fclose(out);
    }
	return 0;
}

